--[[
	Slash
		This is the slash command handler for Bagnon
--]]

function BagnonSlash_Load()
	SlashCmdList["BagnonCOMMAND"] = BagnonSlash;
	SLASH_BagnonCOMMAND1 = "/bagnon";
	SLASH_BagnonCOMMAND2 = "/bgn";
end

function BagnonSlash(msg)
	if(not msg or msg == "" or string.lower(msg) == BAGNON_COMMAND_HELP) then
		BagnonSlash_DisplayHelp();
	else
		local args = {};
		local word;
		for word in string.gfind(msg, "[^%s]+") do
			table.insert(args, word);
		end
		local cmd = string.lower(args[1]);
		
		if(cmd == "" or cmd == BAGNON_COMMAND_HELP) then
			BagnonSlash_DisplayHelp();
		elseif(cmd == BAGNON_COMMAND_SHOWBANK) then
			BagnonCore_Toggle("Banknon");
		elseif(cmd == BAGNON_COMMAND_SHOWBAGS) then
			BagnonCore_Toggle("Bagnon");
		elseif(cmd == BAGNON_COMMAND_OVERRIDE_BANK) then
			BagnonSets_ToggleBankOverride();
		elseif(cmd == BAGNON_COMMAND_TOGGLE_TOOLTIPS) then
			BagnonSets_ToggleTooltips();
		elseif(cmd == BAGNON_COMMAND_DEBUG_ON) then
			BagnonSets.noDebug = nil;
			BagnonMsg(BAGNON_DEBUG_ENABLED);
		elseif(cmd == BAGNON_COMMAND_DEBUG_OFF) then
			BagnonSets.noDebug = 1;
			BagnonMsg(BAGNON_DEBUG_DISABLED);
		elseif(cmd == BAGNON_FOREVER_COMMAND_DELETE_CHARACTER and IsAddOnEnabled("Bagnon_Forever") ) then
			local player = args[2];
			local realm = args[3] or GetRealmName();
			BagnonDB_RemovePlayer(player, realm);
		end
	end
end

function BagnonSlash_DisplayHelp()
	BagnonMsg(BAGNON_HELP_TITLE);
	BagnonMsg(BAGNON_HELP_HELP);
	BagnonMsg(BAGNON_HELP_SHOWBAGS);
	BagnonMsg(BAGNON_HELP_SHOWBANK);
	BagnonMsg(BAGNON_HELP_OVERRIDE_BANK);
	BagnonMsg(BAGNON_HELP_TOGGLE_TOOLTIPS);
	if( IsAddOnLoaded("Bagnon_Forever") ) then
		BagnonMsg(BAGNON_FOREVER_HELP_DELETE_CHARACTER);
	end
end

function BagnonSets_ToggleBankOverride()
	if(BagnonSets.overrideBank == nil) then
		BagnonSets.overrideBank = 1;
		BagnonMsg(BAGNON_BANK_OVERRIDDEN);
	else
		BagnonSets.overrideBank = nil;
		BagnonMsg(BAGNON_BANK_NORMAL);
	end
end

function BagnonSets_ToggleTooltips()
	if(not BagnonSets.showTooltips) then
		BagnonSets.showTooltips = 1;
		BagnonMsg(BAGNON_TOOLTIPS_ENABLED);
	else
		BagnonSets.showTooltips = nil;
		BagnonMsg(BAGNON_TOOLTIPS_DISABLED);
	end
end