-- MetaMap
-- Written by MetaHawk - aka Urshurak
METAMAP_TITLE = "MetaMap";
METAMAP_VERSION = "4.64";
MetaKB_dbID = "db1.1";

METAMAP_NAME = METAMAP_TITLE.."  v"..METAMAP_VERSION;
METAMAPPOI_NAME = "MetaMapPOI";
METAMAP_ICON = "Interface\\WorldMap\\WorldMap-Icon";
METAMAP_MAP_PATH = "Interface\\AddOns\\MetaMap\\Maps\\";
METAMAP_ICON_PATH = "Interface\\AddOns\\MetaMap\\Icons\\";
METAMAP_IMAGE_PATH = "Interface\\AddOns\\MetaMap\\Images\\"
METAMAP_MAPCREDITS = "Maps created by Niflheim";
TITAN_METAMAP_ID = METAMAP_TITLE;
TITAN_METAMAP_FREQUENCY = 1;

METAMAPMENU_BUTTON_HEIGHT = 16;
METAKB_SCROLL_FRAME_BUTTON_HEIGHT = 16;
METAKB_SCROLL_FRAME_BUTTONS_SHOWN = 20;
METAMAPLIST_SCROLL_FRAME_BUTTON_HEIGHT = 20;
METAMAPLIST_SCROLL_FRAME_BUTTONS_SHOWN = 30;

METAKB_SORTBY_NAME = "name";
METAKB_SORTBY_DESC = "desc";
METAKB_SORTBY_LEVEL = "level";
METAKB_SORTBY_LOCATION = "location";

MetaMap_Details = {
	name = METAMAP_TITLE,
	description = METAMAP_DESC,
	version = METAMAP_VERSION,
	releaseDate = "November 26, 2005",
	author = "MetaHawk",
	email = "admin@metaserve.org.uk",
	website = "",
	category = MYADDONS_CATEGORY_MAP,
}

MetaMapOptions = {};
MetaMap_ZoneNames = {};
MetaMap_ZoneNames[0] = {};
MetaMap_ZoneNames[1] = {};
MetaMap_ZoneNames[2] = {};
MetaMap_NoteList = {};

MetaMapNotes_Options = {};
MetaMapNotes_Data = {};
MetaMapNotes_Data[0] = {};
MetaMapNotes_Data[1] = {};
MetaMapNotes_Data[2] = {};
MetaMapNotes_Lines = {};
MetaMapNotes_Lines[0] = {};
MetaMapNotes_Lines[1] = {};
MetaMapNotes_Lines[2] = {};
MetaMapNotes_MiniNote_Data = {};

MetaKB_Data = {};
MetaKB_Data[MetaKB_dbID] = {};
MetaKB_List = {};

MetaMapBLTData = {};

MetaMap_PingTime = 15;
MetaMap_FullScreenMode = false;
MetaMap_sortType = METAKB_SORTBY_NAME;
MetaMap_sortDone = true;
MetaMapZonePOI = true;
MetaMapAllPOI = false;
MetaMap_ListOffset = 0;
MetaMap_VarsLoaded = false;
MetaMapList_SortList = false;

MetaMapNotes_MiniNote_IsInCity = false;
MetaMapNotes_MiniNote_MapzoomInit = false;
MetaMapNotes_Mininote_UpdateRate = 0;
MetaMapNotes_SetNextAsMiniNote = 0;
MetaMapNotes_LastLineClick = {};
MetaMapNotes_LastLineClick.time = 0;
MetaMapNotes_Relocate = {};
MetaMapNotes_Qnote = false;
MetaMapNotes_IconHeight = 16;
MetaMapNotes_IconWidth = 16;
MetaMapNotes_LastNote = 0;
MetaMapNotes_LastLine = 0;
MetaMapNotes_ZoneNotes = 0;

MetaMapNotes_TempData_Id = "";
MetaMapNotes_TempData_Creator = "";
MetaMapNotes_TempData_xPos = "";
MetaMapNotes_TempData_yPos = "";
MetaMapNotes_TempData_Icon = "";
MetaMapNotes_TempData_TextColor = "";
MetaMapNotes_TempData_Info1Color = "";
MetaMapNotes_TempData_Info2Color = "";
MetaMapNotes_TempData_LootID = nil;

MetaMapNotes_PartyNoteData = {};
MetaMapNotes_vnote_xPos = nil;
MetaMapNotes_vnote_yPos = nil;
MetaMapNotes_PartyNoteSet = false;

FWM_ShowUnexplored = false;
FWM_Options = {
    ["Errata"] = {},
		["alpha"] = 1,
		["red"] = 1,
		["green"] = 1,
		["blue"] = 1,
}

MetaKB_overRide = false;
MetaKB_ShowAllZones = false;
MetaKB_ScrollFrameButtonID = 0;

local g_LastSearch = "";
local g_SearchResults = {};
local g_PlayerX = 0;
local g_PlayerY = 0;
local orig_MetaMapNotes_WorldMapButton_OnClick;
local orig_ToggleWorldMap;
local orig_ChatFrame_OnEvent;

METAMAPMENU_LIST = {
	{name = METAMAP_OPTIONS_COORDS},
	{name = METAMAP_OPTIONS_MINICOORDS},
	{name = METAMAP_OPTIONS_SHOWNOTES},
	{name = METAMAP_OPTIONS_SHOWAUTHOR},
	{name = METAMAP_LIST_TEXT},
	{name = METAMAP_ACTION_MODE},
	{name = METAMAP_OPTIONS_SAVESET},
	{name = "Spacer"},
	{name = METAMAP_OPTIONS_EXT},
	{name = METAMAP_FLIGHTMAP_OPTIONS},
	{name = METAMAP_GATHERER_OPTIONS},
	{name = METAMAP_BWP_OPTIONS},
	{name = METAMAP_OPTIONS_USEMAPMOD},
	{name = METAMAP_KB_TEXT},
	{name = METAMAP_OPTIONS_FWM}
};

BlackoutWorld:Hide();
WorldMapZoomOutButton:Hide();
WorldMapFrame:SetMovable(true);
WMF_OldScript = WorldMapFrame:GetScript("OnKeyDown")
WorldMapFrame:SetScript("OnKeyDown", nil);
UIPanelWindows["WorldMapFrame"] =	{ area = "center",	pushable = 0 };

function SetEffectiveScale(frame, scale)
	frame.scale = scale;
	local parent = frame:GetParent();
	if(parent) then
		scale = scale / parent:GetEffectiveScale();
	end
	frame:SetScale(scale);
end

function MetaMapTopFrame_OnLoad()
	math.randomseed(GetTime());
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("WORLD_MAP_UPDATE");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
end

function MetaMapFrameDropDown_OnLoad()
	UIDropDownMenu_ClearAll(MetaMapFrameDropDown);
	UIDropDownMenu_Initialize(MetaMapFrameDropDown, MetaMapFrameDropDown_Initialize);
	UIDropDownMenu_SetWidth(175);
end

function MetaMapList_OnLoad()
	this:SetFrameLevel(WorldMapButton:GetFrameLevel()+1);
	this:SetHeight(WorldMapButton:GetHeight());
	this:SetBackdropColor(0,0,0,0.65);
end

function MetaMapContainerFrame_OnLoad()
	this:SetWidth(WorldMapButton:GetWidth() - MetaMap_MapListFrame:GetWidth()-1);
	this:SetHeight(WorldMapButton:GetHeight()-41);
end

function MetaMapNotes_OnLoad()
	MiniNotePOI.TimeSinceLastUpdate = 0;
	WorldMapMagnifyingGlassButton:SetText(METAMAPNOTES_WORLDMAP_HELP_1.."\n"..METAMAPNOTES_WORLDMAP_HELP_2);
	SlashCmdList["MAPNOTE"] = MetaMapNotes_GetNoteBySlashCommand;
	for i = 1, table.getn(METAMAPNOTES_ENABLE_COMMANDS) do
		setglobal("SLASH_MAPNOTE"..i, METAMAPNOTES_ENABLE_COMMANDS[i]);
	end
	SlashCmdList["MININOTE"] = MetaMapNotes_NextMiniNote;
	for i = 1, table.getn(METAMAPNOTES_MININOTE_COMMANDS) do
		setglobal("SLASH_MININOTE"..i, METAMAPNOTES_MININOTE_COMMANDS[i]);
	end
	SlashCmdList["MININOTEONLY"] = MetaMapNotes_NextMiniNoteOnly;
	for i = 1, table.getn(METAMAPNOTES_MININOTEONLY_COMMANDS) do
		setglobal("SLASH_MININOTEONLY"..i, METAMAPNOTES_MININOTEONLY_COMMANDS[i]);
	end
	SlashCmdList["MININOTEOFF"] = MetaMapNotes_ClearMiniNote;
	for i = 1, table.getn(METAMAPNOTES_MININOTEOFF_COMMANDS) do
		setglobal("SLASH_MININOTEOFF"..i, METAMAPNOTES_MININOTEOFF_COMMANDS[i]);
	end
	SlashCmdList["QUICKNOTE"] = MetaMapNotes_Quicknote;
	for i = 1, table.getn(METAMAPNOTES_QUICKNOTE_COMMANDS) do
		setglobal("SLASH_QUICKNOTE"..i, METAMAPNOTES_QUICKNOTE_COMMANDS[i]);
	end
end

function MetaMapTopFrame_OnShow()
	if(not MetaMap_VarsLoaded) then return; end
	local continent, zone = MetaMap_NameToZoneID(GetRealZoneText());
	local pX, pY = GetPlayerMapPosition("Player");
	if(pX == 0 and pY == 0 and continent == 0) then
		MetaMapOptions.MetaMapZone = zone;
		MetaMap_Toggle(true)
	end
	MetaMapMenu_Init();
	StaticPopup1:SetFrameStrata("FULLSCREEN");
	if(MetaMap_FullScreenMode) then
		MetaMapNotesEditFrame:SetParent("WorldMapFrame");
		MetaMapNotesSendFrame:SetParent("WorldMapFrame");
	end
end

function MetaMap_OnEvent(event)
	if(event == "ADDON_LOADED" and arg1 == "MetaMap") then
		if(MetaMapOptions.SaveSet == nil) then MetaMapOptions.SaveSet = 1; end
		if(MetaMapOptions.MetaMapAlpha1 == nil) then MetaMapOptions.MetaMapAlpha1 = 1.0; end
		if(MetaMapOptions.MetaMapAlpha2 == nil) then MetaMapOptions.MetaMapAlpha2 = 0.60; end
		if(MetaMapOptions.MetaMapScale1 == nil) then MetaMapOptions.MetaMapScale1 = 0.75; end
		if(MetaMapOptions.MetaMapScale2 == nil) then MetaMapOptions.MetaMapScale2 = 0.55; end
		if(MetaMapOptions.MetaMapTTScale1 == nil) then MetaMapOptions.MetaMapTTScale1 = 1.0; end
		if(MetaMapOptions.MetaMapTTScale2 == nil) then MetaMapOptions.MetaMapTTScale2 = 0.75; end
		-- LedMirage 6/21/2006 [1 of 4] Default is now false
		if(MetaMapOptions.MetaMapCoords == nil) then MetaMapOptions.MetaMapCoords = false; end
		-- LedMirage 4/03/2006 [2 of 4] Default is now false		
		if (MetaMapOptions.MetaMapMiniCoords == nil) then MetaMapOptions.MetaMapMiniCoords = false; end
		if(MetaMapOptions.MetaMapButtonShown == nil) then MetaMapOptions.MetaMapButtonShown = true; end
		-- LedMirage 4/03/2006 [3 of 4] changed default minimap button angle from 220 to 312 (304)
		if (MetaMapOptions.MetaMapButtonPosition == nil) then MetaMapOptions.MetaMapButtonPosition = 312; end			
		if(MetaMapOptions.MetaMapMapName == nil) then MetaMapOptions.MetaMapMapName = true; end
		if(MetaMapOptions.MetaMapZone == nil) then MetaMapOptions.MetaMapZone = 1; end
		if(MetaMapOptions.TooltipWrap == nil) then MetaMapOptions.TooltipWrap = true; end
		if(MetaMapOptions.MetaMapShowNotes == nil) then MetaMapOptions.MetaMapShowNotes = true; end
		if(MetaMapOptions.MetaMapShowAuthor == nil) then MetaMapOptions.MetaMapShowAuthor = true; end
		if(MetaMapOptions.MenuMode == nil) then MetaMapOptions.MenuMode = false; end
		if(MetaMapOptions.UseMapMod == nil) then MetaMapOptions.UseMapMod = false; end
		if(MetaMapOptions.ShowUpdates == nil) then MetaMapOptions.ShowUpdates = false; end
		if(MetaMapOptions.CreateMapNotesBoundingBox == nil) then MetaMapOptions.CreateMapNotesBoundingBox = true; end
		if(MetaMapOptions.AutoTrack == nil) then MetaMapOptions.AutoTrack = false; end
		if(MetaMapOptions.KBstate == nil) then MetaMapOptions.KBstate = false; end
		if(MetaMapOptions.NewTargetNote == nil) then MetaMapOptions.NewTargetNote = false; end
		if(MetaMapOptions.ShowMapList == nil) then MetaMapOptions.ShowMapList = false; end
		if(MetaMapOptions.ActionMode1 == nil) then MetaMapOptions.ActionMode = false; end
		if(MetaMapOptions.ActionMode2 == nil) then MetaMapOptions.ActionMode = false; end
		if(MetaMapOptions.RangeCheck == nil) then MetaMapOptions.RangeCheck = 1; end
		if(MetaMapOptions.FWMretain == nil) then MetaMapOptions.FWMretain = false; end
		if(MetaMapOptions.FWMcolor == nil) then MetaMapOptions.FWMcolor = false; end
		if(MetaMapOptions.Dsearch == nil) then MetaMapOptions.Dsearch = true; end
		if(MetaMapOptions.usePOI == nil) then MetaMapOptions.usePOI = false; end
		if(MetaMapOptions.ListColors == nil) then MetaMapOptions.ListColors = true; end
		if(MetaMapOptions.ZoneHeader == nil) then MetaMapOptions.ZoneHeader = false; end
		if(MetaMapOptions.SetMapShow == nil) then MetaMapOptions.SetMapShow = false; end
		if(MetaMapOptions.EmbedKB == nil) then MetaMapOptions.EmbedKB = true; end
	end

	if(event == "VARIABLES_LOADED") then
		MetaMap_LoadZones();
		MetaMap_OptionsDialogInit();
		MetaMapOptions_Init();
		if(MetaMapOptions.FWMretain) then FWM_ShowUnexplored = true; MetaMapFWM_Init(); end
		if(myAddOnsFrame_Register) then
			myAddOnsFrame_Register(MetaMap_Details);
		end
		if MetaMapNotes_MiniNote_Data.icon == "party" then
			MetaMapNotes_ClearMiniNote(true);
		end
		if MetaMapNotes_MiniNote_Data.icon ~= nil then
			MiniNotePOITexture:SetTexture(METAMAP_ICON_PATH.."Icon"..MetaMapNotes_MiniNote_Data.icon);
		end
		orig_MetaMapNotes_WorldMapButton_OnClick = WorldMapButton_OnClick;
		WorldMapButton_OnClick = MetaMapNotes_WorldMapButton_OnClick;
		orig_ChatFrame_OnEvent = ChatFrame_OnEvent;
		ChatFrame_OnEvent = MetaMapNotes_ChatFrame_OnEvent;
		if(MetaKB_Data[MetaKB_dbID] == nil) then
			MetaMap_LoadImports(1);
		end
		MetaMap_VarsLoaded = true;
	MetaMap_StatusPrint("Variables loaded", true);
	end

	if(event == "WORLD_MAP_UPDATE" and MetaMap_VarsLoaded and WorldMapFrame:IsVisible()) then
		MetaMap_Toggle(false);
		if(MetaMapOptions.usePOI) then
			MetaMapPOI_OnEvent(1);
		end
		if(MetaKB_MainFrame:IsVisible() and MetaMapOptions.EmbedKB and not MetaKB_ShowAllZones) then
			MetaKB_Search();
		else
			MetaMapContainerFrame:Hide();
		end
		MetaMapNotes_HideAll();
		MetaMapNotes_MapUpdate();
		MetaMap_ZoneHeader();
	end

	if(event == "ZONE_CHANGED_NEW_AREA" and MetaMap_VarsLoaded) then
		MetaMapNotes_MiniNote_OnUpdate(0);
		if(MetaKB_MainFrame:IsVisible() and not MetaKB_ShowAllZones) then
			MetaKB_Search();
		end
		if(MetaMapOptions.usePOI) then
			MetaMapPOI_OnEvent(2);
		end
		if(WorldMapFrame:IsVisible()) then
			MetaMapNotes_MapUpdate();
		end
	end

	if(event == "PLAYER_ENTERING_WORLD" and MetaMap_VarsLoaded) then
		if(WorldMapFrame:IsVisible()) then
			local continent, zone = MetaMap_NameToZoneID(GetRealZoneText());
			local pX, pY = GetPlayerMapPosition("Player");
			if(pX == 0 and pY == 0 and continent == 0) then
				MetaMapOptions.MetaMapZone = zone;
				MetaMap_Toggle(true);
			end
		end
		MetaMapMiniCoords:SetText("0,0");
		MetaMapMiniCoords:SetTextColor(0, 1, 0);
	end

	if(event == "MINIMAP_UPDATE_ZOOM") then
		MetaMapNotes_MinimapUpdateZoom();
	end

	if(event == "UPDATE_MOUSEOVER_UNIT" and MetaMapOptions.AutoTrack) then
		if(UnitIsPlayer("mouseover")~=1 and UnitPlayerControlled("mouseover")~=1 and UnitIsDead("mouseover")~=1) then
			MetaKB_AddUnitInfo("mouseover");
		end
	end
end

function MetaMap_ToggleFrame(frame)
	if frame:IsVisible() then
		HideUIPanel(frame);
	else
		ShowUIPanel(frame);
	end
end

function MetaMapContainer_ShowFrame(frame, header, footer, info)
	if(IsAddOnLoaded("MetaMapBLT")) then
		MetaMapBLT_SubFrame:Hide();
	end
	MetaKB_MainFrame:Hide();
	MetaMapContainerFrame:Hide();
	if(header ~= nil) then
		MetaMapContainer_HeaderText:SetText(header);
		MetaMapContainer_HeaderText:Show();
	else
		MetaMapContainer_HeaderText:Hide();
	end
	if(footer ~= nil) then
		MetaMapContainer_FooterText:SetText(footer);
		MetaMapContainer_FooterText:Show();
	else
		MetaMapContainer_FooterText:Hide();
	end
	if(info ~= nil) then
		MetaMapContainer_InfoText:SetText(info);
		MetaMapContainer_InfoText:Show();
	else
		MetaMapContainer_InfoText:Hide();
	end
	MetaMapContainerFrame:Show();
	frame:Show();
end

function MetaKB_InitFrame()
	if(MetaMapOptions.EmbedKB) then
		MetaKB_MainFrame:SetParent("MetaMapContainerFrame");
		MetaKB_MainFrame:SetWidth(MetaMapContainerFrame:GetWidth());
		MetaKB_MainFrame:SetHeight(MetaMapContainerFrame:GetHeight());
		MetaKB_MainFrame:SetPoint("CENTER", "MetaMapContainerFrame", "CENTER", 0, 0);
		MetaKB_HeaderPanel:SetHeight(40);
		MetaKB_FooterPanel:SetHeight(60);
		MetaKB_CloseMainFrameButton:Hide();
		METAKB_SCROLL_FRAME_BUTTON_HEIGHT = 18;
		METAKB_SCROLL_FRAME_BUTTONS_SHOWN = 30;
	else
		MetaKB_MainFrame:SetParent("MetaKB_OuterFrame");
		MetaKB_MainFrame:SetWidth(710);
		MetaKB_MainFrame:SetHeight(365);
		MetaKB_MainFrame:SetPoint("CENTER", "MetaKB_OuterFrame", "CENTER", 0, 0);
		MetaKB_HeaderPanel:SetHeight(22);
		MetaKB_FooterPanel:SetHeight(40);
		MetaKB_CloseMainFrameButton:Show();
		METAKB_SCROLL_FRAME_BUTTON_HEIGHT = 16;
		METAKB_SCROLL_FRAME_BUTTONS_SHOWN = 20;
	end
	MetaKB_HeaderPanel:SetWidth(MetaKB_HeaderPanel:GetParent():GetWidth());
	MetaKB_HeaderPanel:SetFrameLevel(MetaKB_HeaderPanel:GetParent():GetFrameLevel()+1);
	MetaKB_FooterPanel:SetWidth(MetaKB_FooterPanel:GetParent():GetWidth());
	MetaKB_FooterPanel:SetFrameLevel(MetaKB_FooterPanel:GetParent():GetFrameLevel()+1);
	MetaKB_ScrollFrame:SetHeight(MetaKB_ScrollFrame:GetParent():GetHeight() - (MetaKB_HeaderPanel:GetHeight()+MetaKB_FooterPanel:GetHeight()));
	MetaKB_ScrollFrame:SetWidth(MetaKB_ScrollFrame:GetParent():GetWidth()-22);
	for i=1, METAKB_SCROLL_FRAME_BUTTONS_SHOWN,1 do
		getglobal("MetaKB_ScrollFrameButton"..i.."Name"):SetWidth(MetaKB_Header1:GetWidth());
		getglobal("MetaKB_ScrollFrameButton"..i.."Info1"):SetWidth(MetaKB_Header2:GetWidth());
		getglobal("MetaKB_ScrollFrameButton"..i.."Info2"):SetWidth(MetaKB_Header3:GetWidth());
		getglobal("MetaKB_ScrollFrameButton"..i.."Coords"):SetWidth(MetaKB_Header4:GetWidth());
	end
end

function MetaMap_FullScreenToggle()
	local mMap = false;
	local continent = GetCurrentMapContinent();
	local zone = GetCurrentMapZone();
	if(MetaMapFrame:IsVisible()) then
		MetaMapShown = true;
	end
	if(MetaMap_FullScreenMode) then
		WorldMapFrame:SetMovable(true);
		WorldMapFrame:SetScript("OnKeyDown", nil);
		WorldMapFrame:SetScript("OnKeyUp", nil);
		UIPanelWindows["WorldMapFrame"] =	{ area = "center",	pushable = 9 };
		MetaMapNotesEditFrame:SetParent("UIParent");
		MetaMapNotesEditFrame:SetFrameStrata("FULLSCREEN");
		MetaMapNotesSendFrame:SetParent("UIParent");
		MetaMapNotesSendFrame:SetFrameStrata("FULLSCREEN");
		MetaMapMenu:SetParent("UIParent");
		MetaMapMenu:SetFrameStrata("FULLSCREEN");
		UIPanelWindows['MetaMapMenu'] = {area = 'center', pushable = 0};
		MetaMap_FullScreenMode = false;
		BlackoutWorld:Hide();
		if(WorldMapFrame:IsVisible()) then
			CloseAllWindows();
			ShowUIPanel(WorldMapFrame);
		end
		MetaMapOptions_Init();
	else
		MetaMapMenu:SetParent("WorldMapFrame");
		MetaMapNotesEditFrame:SetParent("WorldMapFrame");
		MetaMapNotesSendFrame:SetParent("WorldMapFrame");
		WorldMapFrame:SetMovable(false);
		WorldMapFrame:SetScale(1.0);
		WorldMapFrame:SetScript("OnKeyDown", WMF_OldScript);
		WorldMapFrame:SetScript("OnKeyUp", X_Frame:GetScript("OnKeyUp"));
		UIPanelWindows["WorldMapFrame"] =	{ area = "full",	pushable = 0 };
		BlackoutWorld:Show();
		MetaMap_FullScreenMode = true;
		if(WorldMapFrame:IsVisible()) then
			CloseAllWindows();
			ShowUIPanel(WorldMapFrame);
		end
	end
	SetMapZoom(continent, zone);
	if(MetaMapShown) then MetaMap_Toggle(true); end
end

function MetaMap_Toggle(show)
	if(show) then
		ShowUIPanel(MetaMapFrame);
		HideUIPanel(WorldMapDetailFrame);
		HideUIPanel(WorldMapButton);
		ShowWorldMapArrowFrame(0);
		if(IsAddOnLoaded("CT_MapMod")) then
			WorldMapFrameCreateNoteOnPlayer:Disable();
		end
		MetaMap_Refresh();
		if(MetaKB_MainFrame:IsVisible() and MetaMapOptions.EmbedKB and not MetaKB_ShowAllZones) then
			MetaKB_Search();
		end
	else
		HideUIPanel(MetaMapFrame);
		ShowUIPanel(WorldMapDetailFrame);
		ShowUIPanel(WorldMapButton);
		ShowWorldMapArrowFrame(1);
		if(IsAddOnLoaded("CT_MapMod")) then
			WorldMapFrameCreateNoteOnPlayer:Enable();
		end
		if(MetaKB_MainFrame:IsVisible() and MetaMapOptions.EmbedKB and not MetaKB_ShowAllZones) then
			MetaKB_Search();
		else
			MetaMapContainerFrame:Hide();
		end
	end
end

function MetaKB_ToggleFrame(mode)
	if(MetaMapOptions.EmbedKB) then
		if(mode ~= nil and mode == 2) then
			if(not WorldMapFrame:IsVisible()) then
				MetaMap_ToggleFrame(WorldMapFrame);
			else
				if(MetaKB_MainFrame:IsVisible()) then
					MetaMap_ToggleFrame(WorldMapFrame);
				end
			end
		else
			if(not WorldMapFrame:IsVisible()) then
				MetaMap_ToggleFrame(WorldMapFrame);
			end
		end
		if(MetaKB_MainFrame:IsVisible()) then
			MetaKB_MainFrame:GetParent():Hide();
		else
			MetaMapContainer_ShowFrame(MetaKB_MainFrame);
		end
	else
		MetaMap_ToggleFrame(MetaKB_MainFrame:GetParent());
	end
	MetaMapOptions_Init();
end

function MetaMap_UpdateAlpha()
	if(MetaMapOptions.SaveSet == 1) then
		MetaMapOptions.MetaMapAlpha1 = MetaMapAlphaSlider:GetValue();
		WorldMapFrame:SetAlpha(MetaMapOptions.MetaMapAlpha1);
	else
		MetaMapOptions.MetaMapAlpha2 = MetaMapAlphaSlider:GetValue();
		WorldMapFrame:SetAlpha(MetaMapOptions.MetaMapAlpha2);
	end
	MetaMapMainCoords:SetAlpha(255);
	MetaMapMenu:SetAlpha(255);
	WorldMapButton:SetAlpha(MetaMapAlphaSlider:GetValue() + 0.2);
end

function MetaMap_UpdateScale()
	if(not MetaMap_FullScreenMode) then
		if(MetaMapOptions.SaveSet == 1) then
			MetaMapOptions.MetaMapScale1 = MetaMapScaleSlider:GetValue();
			SetEffectiveScale(WorldMapFrame, MetaMapOptions.MetaMapScale1);
		else
			MetaMapOptions.MetaMapScale2 = MetaMapScaleSlider:GetValue();
			SetEffectiveScale(WorldMapFrame, MetaMapOptions.MetaMapScale2);
		end
		MetaMapTopFrame:SetWidth(WorldMapButton:GetWidth()+10);
		MetaMapTopFrame:SetHeight(WorldMapButton:GetHeight()+100);
	end
end

function MetaMap_UpdateTTScale()
	if(MetaMapOptions.SaveSet == 1) then
		MetaMapOptions.MetaMapTTScale1 = MetaMapTTScaleSlider:GetValue();
		SetEffectiveScale(WorldMapTooltip, MetaMapOptions.MetaMapTTScale1);
	else
		MetaMapOptions.MetaMapTTScale2 = MetaMapTTScaleSlider:GetValue();
		SetEffectiveScale(WorldMapTooltip, MetaMapOptions.MetaMapTTScale2);
	end
end

function MetaMap_InitFWMcolor()
	ColorPickerFrame.func = MetaMap_SetFWMcolor;
	ColorPickerFrame.cancelFunc = MetaMap_CancelFWMcolor;
	ColorPickerFrame.previousValues = {FWM_Options.red, FWM_Options.green, FWM_Options.blue};
	ColorPickerFrame:SetFrameStrata("FULLSCREEN");
	ColorPickerFrame:Show();
	ColorPickerFrame:SetColorRGB(FWM_Options.red, FWM_Options.green, FWM_Options.blue);
end

function MetaMap_SetFWMcolor()
	FWM_Options.red, FWM_Options.green, FWM_Options.blue = ColorPickerFrame:GetColorRGB();
	WorldMapFrame_Update();
end

function MetaMap_CancelFWMcolor(prevColors)
	FWM_Options.red, FWM_Options.green, FWM_Options.blue = unpack(prevColors);
	WorldMapFrame_Update();
end

function MetaMapFrameDropDown_Initialize()
	local DropDownList = {};
	for zoneKey in MetaMap_Data do
		local detail = {zone = zoneKey, location = MetaMap_Data[zoneKey]["ZoneName"]};
    table.insert(DropDownList, detail);
	end
	local sort = MetaMap_sortType;
	MetaMap_sortType = METAKB_SORTBY_LOCATION;
  table.sort(DropDownList, MetaSort_Criteria);
	MetaMap_sortType = sort;

	for zoneKey in DropDownList do
		local info = {
			text = DropDownList[zoneKey]["location"];
			value = DropDownList[zoneKey]["zone"];
			func = MetaMapDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_SetSelectedValue(MetaMapFrameDropDown, MetaMapOptions.MetaMapZone);
end

function MetaMapDropDown_OnClick()
	local id = this:GetID();
	UIDropDownMenu_SetSelectedID(MetaMapFrameDropDown, id);
	MetaMapOptions.MetaMapZone = this.value;
	MetaMap_Toggle(true);
end

function MetaMap_Refresh()
	if(MetaMapOptions.MetaMapZone > 0 and MetaMapOptions.MetaMapZone < table.getn(MetaMap_Data)+1) then
		MetaMapMap:SetTexture(METAMAP_MAP_PATH..MetaMap_Data[MetaMapOptions.MetaMapZone]["texture"]);
		MetaMapText_Instance:SetText("|cffffffff"..MetaMap_Data[MetaMapOptions.MetaMapZone]["ZoneName"]);
		MetaMapText_Location:SetText(METAMAP_STRING_LOCATION..": ".."|cffffffff"..MetaMap_Data[MetaMapOptions.MetaMapZone]["Location"]);
		MetaMapText_LevelRange:SetText(METAMAP_STRING_LEVELRANGE..": ".."|cffffffff"..MetaMap_Data[MetaMapOptions.MetaMapZone]["LevelRange"]);
		MetaMapText_PlayerLimit:SetText(METAMAP_STRING_PLAYERLIMIT..": ".."|cffffffff"..MetaMap_Data[MetaMapOptions.MetaMapZone]["PlayerLimit"]);
		if(MetaKB_MainFrame:IsVisible() and MetaMapOptions.EmbedKB and not MetaKB_ShowAllZones) then
			MetaKB_Search();
		else
			MetaMapContainerFrame:Hide();
		end
		MetaMapNotes_MapUpdate();
	end
end

function MetaMapMenu_Init()
	MetaMapButton.haveAbilities = true;
	local x = 1; local y = 1;
	for i, menudata in METAMAPMENU_LIST do
		local flag = false;
		getglobal("MetaMapMenu_Option"..x):SetHeight(METAMAPMENU_BUTTON_HEIGHT);
		local button = getglobal("MetaMapMenu_Option"..x);
		if(x == 1) then
			button.toggle = MetaMapOptions.MetaMapCoords;
		elseif(x == 2) then
			button.toggle = MetaMapOptions.MetaMapMiniCoords;
		elseif(x == 3) then
			button.toggle = MetaMapOptions.MetaMapShowNotes;
		elseif(x == 4) then
			button.toggle = MetaMapOptions.MetaMapShowAuthor;
		elseif(x == 5) then
			button.toggle = MetaMapOptions.ShowMapList;
		elseif(x == 6) then
			if(MetaMapOptions.SaveSet == 1) then
				button.toggle = MetaMapOptions.ActionMode1;
			else
				button.toggle = MetaMapOptions.ActionMode2;
			end
		elseif(x == 7) then
			button.toggle = false;
			getglobal("MetaMapMenu_Option"..x.."Text"):SetText(MetaMapOptions.SaveSet)
		elseif(x == 8) then
			-- spacer
		elseif(x ==9) then
			button.toggle = false;
		elseif(x == 10) then
			if(IsAddOnLoaded("FlightMap")) then
				button.toggle = false;
			else
				flag = true;
			end
		elseif(x == 11) then
			if(IsAddOnLoaded("Gatherer")) then
				button.toggle = false;
			else
				flag = true;
			end
		elseif(x == 12) then
			if(IsAddOnLoaded("BetterWaypoints")) then
				button.toggle = false;
			else
				flag = true;
			end
		elseif(x == 13) then
			if(IsAddOnLoaded("CT_MapMod")) then
				button.toggle = MetaMapOptions.UseMapMod;
			else
				MetaMapOptions.UseMapMod = false;
				flag = true;
			end
		elseif(x == 14) then
			button.toggle = false;
		elseif(x == 15) then
			button.toggle = FWM_ShowUnexplored;
		end
		
		if(flag) then
			button:SetHeight(1);
			button:Hide();
			y = y - 1;
		elseif(menudata.name == "Spacer") then
			button:SetHeight(8);
			button:Hide();
		else
			if button.toggle then
				getglobal("MetaMapMenu_Option"..x.."Check"):Show();
			else
				getglobal("MetaMapMenu_Option"..x.."Check"):Hide();
			end
			button:SetText(menudata.name);
			button:Show();
		end
		x = x + 1; y = y + 1;
	end
	MetaMapMenu:SetHeight((METAMAPMENU_BUTTON_HEIGHT * y) + (METAMAPMENU_BUTTON_HEIGHT * 2));
	MetaMapOptions_Init();
end

function MetaMapMenu_Select(id)
	id = tonumber(id)
	local button = getglobal("MetaMapMenu_Option"..id);
	if button.toggle then
		button.toggle = false;
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	else
		button.toggle = true;
		getglobal("MetaMapMenu_Option"..id.."Check"):Show()
	end
	if(id == 1) then
		MetaMapOptions.MetaMapCoords = button.toggle;
	elseif(id == 2) then
		MetaMapOptions.MetaMapMiniCoords = button.toggle;
	elseif(id == 3) then
		MetaMapOptions.MetaMapShowNotes = button.toggle;
	elseif(id == 4) then
		MetaMapOptions.MetaMapShowAuthor = button.toggle;
	elseif(id == 5) then
		MetaMapOptions.ShowMapList = button.toggle;
	elseif(id == 6) then
		ActionMode = button.toggle;
		if(MetaMapOptions.SaveSet == 1) then
			MetaMapOptions.ActionMode1 = button.toggle;
		else
			MetaMapOptions.ActionMode2 = button.toggle;
		end
	elseif(id == 7) then
		MetaMapSaveSet_Toggle();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
		getglobal("MetaMapMenu_Option"..id.."Text"):SetText(MetaMapOptions.SaveSet)
	elseif(id ==8) then
		-- spacer
	elseif(id == 9) then
		MetaMapExtOptions_Toggle();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	elseif(id == 10) then
		FlightMapOptions_Toggle();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	elseif(id == 11) then
		GathererOptions_Toggle();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	elseif(id == 12) then
		BWP_Toggle();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	elseif(id == 13) then
		MetaMapOptions.UseMapMod = button.toggle;
	elseif(id == 14) then
		MetaKB_ToggleFrame();
		getglobal("MetaMapMenu_Option"..id.."Check"):Hide()
	elseif(id == 15) then
		FWM_ShowUnexplored = button.toggle;
		MetaMapFWM_Init();
	end
	MetaMapOptions_Init();	
end

function MetaMapMenu_OnShow(mode)
	MetaMapMenu:ClearAllPoints();
	local x, y = GetCursorPosition();
	if(MetaMap_FullScreenMode) then
		x = x / WorldMapFrame:GetEffectiveScale();
		y = y / WorldMapFrame:GetEffectiveScale();
	else
		x = x / UIParent:GetEffectiveScale();
		y = y / UIParent:GetEffectiveScale();
	end
	if(mode == "Minimap") then
		MetaMapMenu:SetPoint("TOPRIGHT", "UIParent", "BOTTOMLEFT", x + 10, y + 10);
		MetaMapSliderMenu:Show();
		MetaMapButtonSlider:Show();
		MetaMapAlphaSlider:Hide();
		MetaMapScaleSlider:Hide();
		MetaMapTTScaleSlider:Hide();
		MetaMapSliderMenu:SetHeight(55);
		MetaMapMenu:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	elseif(mode == "Mainmap") then
		MetaMapMenu:SetPoint("TOP", "UIParent", "BOTTOMLEFT", x, y);
		MetaMapSliderMenu:Show();
		MetaMapButtonSlider:Hide();
		MetaMapAlphaSlider:Show();
		MetaMapScaleSlider:Show();
		MetaMapTTScaleSlider:Show();
		MetaMapSliderMenu:SetHeight(105);
		MetaMapMenu:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	elseif(mode == "Titan") then
		MetaMapMenu:SetPoint("TOP", "UIParent", "BOTTOMLEFT", x, y);
		MetaMapSliderMenu:Hide();
		MetaMapMenu:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 32, edgeSize = 16, insets = { left = 5, right = 5, top = 5, bottom = 5 }});
	end
	MetaMapMenu:Show();
end

function MetaMapMenu_OnUpdate()
	if (MetaMapMenu:IsVisible()) then
		if (not MouseIsOver(MetaMapMenu) and not MouseIsOver(MetaMapButton) and not MouseIsOver(MetaMapFrameOptionsButton) and not MouseIsOver(MetaMapSliderMenu) and not MouseIsOver(TitanPanelMetaMapButton)) then
			MetaMapMenu:Hide();
			MetaMapOptions_Init();
		end
	end
end

function MetaMap_ToggleDialog(tab)
	local subFrame = getglobal(tab);
	MetaMap_GeneralDialog:Hide();
	MetaMap_NotesDialog:Hide();
	MetaKB_OptionsFrame:Hide();
	MetaMap_FWMDialog:Hide();
	MetaMap_ImportDialog:Hide();
	if(subFrame) then
		if(MetaMap_DialogFrame:IsVisible()) then
			PlaySound("igCharacterInfoTab");
			getglobal(tab):Show();
		else
			ShowUIPanel(MetaMap_DialogFrame);
			getglobal(tab):Show();
		end
	end
end

function MetaMap_OptionsTab_OnClick()
	if(this:GetName() == "MetaMap_DialogFrameTab1") then
		MetaMap_ToggleDialog("MetaMap_GeneralDialog");
	elseif(this:GetName() == "MetaMap_DialogFrameTab2") then
		MetaMap_ToggleDialog("MetaMap_NotesDialog");
	elseif(this:GetName() == "MetaMap_DialogFrameTab3") then
		MetaMap_ToggleDialog("MetaKB_OptionsFrame");
	elseif(this:GetName() == "MetaMap_DialogFrameTab4") then
		MetaMap_ToggleDialog("MetaMap_FWMDialog");
	elseif(this:GetName() == "MetaMap_DialogFrameTab5") then
		MetaMap_ToggleDialog("MetaMap_ImportDialog");
	end
	PlaySound("igCharacterInfoTab");
end

function MetaMapExtOptions_Toggle()
	if(MetaMap_DialogFrame:IsVisible()) then
		HideUIPanel(MetaMap_DialogFrame);
	else
		if(MetaMap_FullScreenMode) then
			MetaMap_DialogFrame:SetParent("WorldMapFrame");
		end
		ShowUIPanel(MetaMap_DialogFrame);
	end
end

function MetaMapSaveSet_Toggle()
	if(MetaMapOptions.SaveSet == 1) then
		MetaMapOptions.SaveSet = 2;
	else
		MetaMapOptions.SaveSet = 1;
	end
	MetaMapOptions_Init();
end

function MetaMapFWM_Init()
	if(not IsAddOnLoaded("MetaMapFWM")) then
		LoadAddOn("MetaMapFWM");
	end
	if(IsAddOnLoaded("MetaMapFWM")) then
		WorldMapFrame_Update();
	else
		FWM_ShowUnexplored = false;
		MetaMap_StatusPrint("MetaMapFWM addon is not enabled!", true);
	end
end

function MetaMap_OptionsDialogInit()
	MetaMap_MenuModeCheckButton:SetChecked(MetaMapOptions.MenuMode);
	MetaMap_TTWrapCheckButton:SetChecked(MetaMapOptions.TooltipWrap);
	MetaMap_MiniButtonCheckButton:SetChecked(MetaMapOptions.MetaMapButtonShown);
	MetaMap_POICheckButton:SetChecked(MetaMapOptions.usePOI);
	MetaMap_ListColorsButton:SetChecked(MetaMapOptions.ListColors);
	MetaMap_ZoneHeaderButton:SetChecked(MetaMapOptions.ZoneHeader);
	MetaMap_POIZoneCheckButton:SetChecked(MetaMapZonePOI);
	MetaMap_POIAllButton:SetChecked(MetaMapAllPOI);
	MetaMap_FWMpersistCheckButton:SetChecked(MetaMapOptions.FWMretain);
	MetaMap_FWMcolorCheckButton:SetChecked(MetaMapOptions.FWMcolor);
	MetaKB_ShowUpdatesCheckButton:SetChecked(MetaMapOptions.ShowUpdates);
	MetaKB_BoundingBoxCheckButton:SetChecked(MetaMapOptions.CreateMapNotesBoundingBox);
	MetaKB_AutoTrackingCheckButton:SetChecked(MetaMapOptions.AutoTrack);
	MetaKB_DsearchCheckButton:SetChecked(MetaMapOptions.Dsearch);
	MetaKB_UseKBCheckButton:SetChecked(MetaMapOptions.KBstate);
	MetaKB_SetTargetNoteCheckButton:SetChecked(MetaMapOptions.NewTargetNote);
	MetaKB_SetMapShowCheckButton:SetChecked(MetaMapOptions.SetMapShow);
	MetaKB_EmbedCheckButton:SetChecked(MetaMapOptions.EmbedKB);
	MetaKB_ToggleSetRange(MetaMapOptions.RangeCheck);
end

function MetaMapOptions_Init()
	local ActionMode = false;

	MetaMapButtonSlider:SetValue(MetaMapOptions.MetaMapButtonPosition);
	MetaMapButton_UpdatePosition();
	
	if(MetaMapOptions.SaveSet == 1) then
		if(MetaMapOptions.MetaMapAlpha1 < 0.15) then MetaMapOptions.MetaMapAlpha1 = 0.15; end
		MetaMapScaleSlider:SetValue(MetaMapOptions.MetaMapScale1);
		MetaMapAlphaSlider:SetValue(MetaMapOptions.MetaMapAlpha1);
		MetaMapTTScaleSlider:SetValue(MetaMapOptions.MetaMapTTScale1);
		ActionMode = MetaMapOptions.ActionMode1;
	else
		if(MetaMapOptions.MetaMapAlpha2 < 0.15) then MetaMapOptions.MetaMapAlpha2 = 0.15; end
		MetaMapScaleSlider:SetValue(MetaMapOptions.MetaMapScale2);
		MetaMapAlphaSlider:SetValue(MetaMapOptions.MetaMapAlpha2);
		MetaMapTTScaleSlider:SetValue(MetaMapOptions.MetaMapTTScale2);
		ActionMode = MetaMapOptions.ActionMode2;
	end

	if(ActionMode) then
		WorldMapButton:EnableMouse(false);
		MetaMapTopFrame:EnableMouse(false);
		MetaMapFrame:EnableMouse(false);
	else
		WorldMapButton:EnableMouse(true);
		MetaMapTopFrame:EnableMouse(true);
		MetaMapFrame:EnableMouse(true);
	end

	if(MetaMapOptions.MetaMapButtonShown) then
		MetaMapButton:Show();
	else
		MetaMapButton:Hide();
	end

	if(MetaMapOptions.MetaMapCoords) then
		MetaMapMainCoords:Show();
	else
		MetaMapMainCoords:Hide();
	end
	if(MetaMapOptions.MetaMapMiniCoords) then
		MetaMap_MiniCoords:Show();
	else
		MetaMap_MiniCoords:Hide();
	end
	if(MetaMapOptions.ShowMapList) then
		MetaMapList_Init();
	else
		MetaMap_MapListFrame:Hide();
	end
	MetaKB_InitFrame();
	MetaMap_UpdateAlpha();
	MetaMap_UpdateScale();
	MetaMap_UpdateTTScale();
	MetaMapNotes_MapUpdate();
end

-- LedMirage 4/03/2006 [4 of 4] changed values to match IX rotation scheme 
function MetaMapButton_UpdatePosition()
	MetaMapButton:SetPoint("TOPLEFT", "Minimap", "TOPLEFT",
		57 - (80 * cos(MetaMapOptions.MetaMapButtonPosition)),
		(80 * sin(MetaMapOptions.MetaMapButtonPosition)) - 58
	);
end

function MetaMap_ButtonTooltip()
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:SetText(METAMAP_TITLE, 0, 1, 0);
	GameTooltip:AddLine(METAMAP_BUTTON_TOOLTIP1, 1, 1, 1);
	if(MetaMapOptions.MenuMode) then
		GameTooltip:AddLine(METAMAP_BUTTON_TOOLTIP2, 1, 1, 1);
	end
	GameTooltip:Show();
end

function MetaMap_round(num, idp)
  local mult = 10^(idp or 0);
  return (math.floor(num * mult + 0.5) / mult);
end

function MiniMapCoords_OnClick()
	if (ChatFrameEditBox:IsVisible()) then
		local msg = "My location: "..GetRealZoneText().." ("..MetaMapMiniCoords:GetText()..")";
		ChatFrameEditBox:Insert(msg);
	end
end

function MiniMapCoords_OnUpdate()
	if (MetaMapOptions.MetaMapMiniCoords and Minimap:IsVisible()) then
		local continent, zone = MetaMap_NameToZoneID(GetRealZoneText());
		MetaMapMiniCoords:Show();
		if(GetCurrentMapContinent() == continent and GetCurrentMapZone() == zone) then
			local output = "";
			local px, py = GetPlayerMapPosition("player");
			output = MetaMap_round(px * 100)..","..MetaMap_round(py * 100);
			MetaMapMiniCoords:SetText(output);
			MetaMapMiniCoords:SetTextColor(0, 1, 0);
		end
	else
		MetaMapMiniCoords:Hide();
	end
end

function MetaMapCoordsWorldMap_OnUpdate()
	if (MetaMapOptions.MetaMapCoords and WorldMapFrame:IsVisible()) then
		local x, y = GetCursorPosition();
		local px, py = GetPlayerMapPosition("player");
		local OFFSET_X = 0.0022;
		local OFFSET_Y = -0.0262;
		local centerX, centerY = WorldMapFrame:GetCenter();
		local width = WorldMapButton:GetWidth();
		local height = WorldMapButton:GetHeight();
		x = x / WorldMapFrame:GetEffectiveScale();
		y = y / WorldMapFrame:GetEffectiveScale();
		local adjustedX = (x - (centerX - (width/2))) / width;
		local adjustedY = (centerY + (height/2) - y ) / height;
		x = 100 * (adjustedX + OFFSET_X);
		y = 100 * (adjustedY + OFFSET_Y);
		if(x < 0 or y < 0 or x > 100 or y > 100) then
			output1 = "";
		else
			output1 = "|cffffffff"..format("%d,%d",x, y);
		end
		output2 = "|cff00ff00"..MetaMap_round(px * 100)..","..MetaMap_round(py * 100);
		MetaMapCoordsCursor:SetText(output1);
		MetaMapCoordsPlayer:SetText(output2);
	end
end

function MetaMap_LoadZones()
	if(MetaMapNotes_Data == nil) then
		MetaMapNotes_Data[0] = {};
	end
	for zoneKey in MetaMap_Data do
		if(MetaMapNotes_Data[0][zoneKey] == nil) then
			MetaMapNotes_Data[0][zoneKey] = {};
		end
		if(MetaMapNotes_Lines[0][zoneKey] == nil) then
			MetaMapNotes_Lines[0][zoneKey] = {};
		end
		MetaMap_ZoneNames[0][zoneKey] = MetaMap_Data[zoneKey]["ZoneName"];
	end
	for continentKey,continentName in ipairs{GetMapContinents()} do
		MetaMap_ZoneNames[continentKey] = {};
		for zoneKey,zoneName in ipairs{GetMapZones(continentKey)} do
			if(MetaMapNotes_Data[continentKey][zoneKey] == nil) then
				MetaMapNotes_Data[continentKey][zoneKey] = {};
			end
			if(MetaMapNotes_Lines[continentKey][zoneKey] == nil) then
				MetaMapNotes_Lines[continentKey][zoneKey] = {};
			end
			MetaMap_ZoneNames[continentKey][zoneKey] = zoneName;
		end
	end
end

function MetaMap_NameToZoneID(zoneText, mode)
	for continentKey in MetaMapNotes_Data do
		if zoneText == MetaMap_ZoneNames[continentKey] then
			return zoneText;
		end
	end
	for continentKey in MetaMap_ZoneNames do
		for zoneKey in MetaMap_ZoneNames[continentKey] do
			if zoneText == MetaMap_ZoneNames[continentKey][zoneKey] then
				return continentKey, zoneKey;
			end
		end
	end
	if(type(zoneText) == "string" and strlen(zoneText) >0 and mode == nil) then
		if(MetaMapNotes_Data[zoneText] == nil) then
			MetaMapNotes_Data[zoneText] = {};
			MetaMapNotes_Lines[zoneText] = {};
		end
		return zoneText;
	end
	return 0, 0;
end

function MetaMap_GetCurrentMapInfo()
	local continent, zone, currentZone, mapName;
	continent = GetCurrentMapContinent();
	zone = GetCurrentMapZone();
	if(MetaMapFrame:IsVisible()) then
		continent = 0;
		zone = MetaMapOptions.MetaMapZone;
		currentZone = MetaMapNotes_Data[continent][zone];
		mapName = MetaMap_Data[zone]["ZoneName"];
	elseif(continent == -1) then
		if(MetaMapNotes_Data[GetRealZoneText()] == nil) then
			MetaMapNotes_Data[GetRealZoneText()] = {};
			MetaMapNotes_Lines[GetRealZoneText()] = {};
		end
		currentZone = MetaMapNotes_Data[GetRealZoneText()];
		mapName = GetRealZoneText();
	elseif(continent > 0) then
		currentZone = MetaMapNotes_Data[continent][zone];
		mapName = MetaMap_ZoneNames[continent][zone];
	end
	if(continent == 1 and mapName == nil) then
		mapName = "Kalimdor";
	elseif(continent == 2 and mapName == nil) then
		mapName = "Eastern Kingdoms";
	elseif(mapName == nil) then
		mapName = "World";
	end
	return continent, zone, currentZone, mapName;
end

function MetaMapList_Init()
	if(not MetaMapOptions.ShowMapList) then
		return;
	end
	MetaMap_MapListFrame:Show();
	MetaMapPing_OnUpdate(30)
	FauxScrollFrame_SetOffset(MetaMapList_ScrollFrame, MetaMap_ListOffset);
	MetaMapList_BuildList();
	if(not MetaMap_NoteList[1]) then
		MetaMap_MapListFrame:Hide();
		return;
	end
	MetaMapList_UpdateScroll();
end

function MetaMapList_OnClick(button, id)
	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	if(button	== "LeftButton")	then
		if(IsControlKeyDown())	then
			if(not IsAddOnLoaded("MetaMapBLT")) then
				LoadAddOn("MetaMapBLT");
			end
			if(IsAddOnLoaded("MetaMapBLT")) then
				local LootID = MetaMapNotes_Data[continent][zone][id].lootid;
				local Name = MetaMapNotes_Data[continent][zone][id].name;
				MetaMapBLT_OnSelect(LootID, Name);
			else
				MetaMap_StatusPrint(METAMAPBLT_NOT_ENABLED, true);
			end
		elseif(IsShiftKeyDown() and ChatFrameEditBox:IsVisible())	then
			if(not currentZone) then return; end
			local tname = currentZone[id].name;
			local tinf1 = currentZone[id].inf1;
			local x = MetaMap_round(currentZone[id].xPos *100);
			local y = MetaMap_round(currentZone[id].yPos *100);
			local tzone = MetaMap_ZoneNames[continent][zone];
			if(strlen(tinf1) > 0) then tinf1 = " ["..tinf1.."] "; end
			local msg = tname.." "..tinf1.." ("..tzone.." - "..x..","..y..")";
			ChatFrameEditBox:Insert(msg);
		else
			MetaMapPing_SetPing(this:GetID() + MetaMap_ListOffset);
		end
	elseif(button	== "RightButton")	then
		if(IsControlKeyDown() or IsShiftKeyDown()) then
			-- Maybe for other functions.
		else
			MetaMapNotes_Note_OnClick("LeftButton",	id);
		end
	end
end

function MetaMapList_BuildList()
	MetaMap_NoteList = {};
	local zone = GetCurrentMapZone();
	local continent = GetCurrentMapContinent();
	local selectedZone;
	MetaMapList_InfoText:Hide();
	MetaMapList_PlayerButton:Hide();

	if(MetaMapFrame:IsVisible()) then
		continent = 0;
		selectedZone = MetaMapNotes_Data[0][MetaMapOptions.MetaMapZone];
	elseif(continent == -1) then
		selectedZone = MetaMapNotes_Data[GetRealZoneText()];
	else
		selectedZone = MetaMapNotes_Data[continent][zone];
	end
	local playerContinent, playerZone = MetaMap_NameToZoneID(GetRealZoneText());
	if(continent == playerContinent and zone == playerZone and not MetaMapFrame:IsVisible()) then
		getglobal("MetaMapList_PlayerButton".."Name"):SetText("Show "..UnitName("Player").."'s Position");
		MetaMapList_PlayerButton:Show();
	elseif(MetaMapFrame:IsVisible()) then
		MetaMapList_InfoText:Show();
	end
	if(not selectedZone or zone < 0) then
		MetaMap_MapListFrame:Hide();
	else
		for i, value in selectedZone do
			MetaMap_NoteList[i] = {};
			MetaMap_NoteList[i]["name"] = selectedZone[i]["name"];
			MetaMap_NoteList[i]["xPos"] = selectedZone[i]["xPos"];
			MetaMap_NoteList[i]["yPos"] = selectedZone[i]["yPos"];
			MetaMap_NoteList[i]["ncol"] = selectedZone[i]["ncol"];
			MetaMap_NoteList[i]["id"] = i;
			MetaMap_NoteList.lastEntry = i;
		end
		if(MetaMapList_SortList) then
			local sort = MetaMap_sortType;
			MetaMap_sortType = METAKB_SORTBY_NAME;
		  table.sort(MetaMap_NoteList, MetaSort_Criteria);
			MetaMap_sortType = sort;
		end
	end
end

function MetaMapList_UpdateScroll()
	for i = 1, METAMAPLIST_SCROLL_FRAME_BUTTONS_SHOWN, 1 do
		local buttonIndex = i + FauxScrollFrame_GetOffset(MetaMapList_ScrollFrame);
		local scrollFrameButton = getglobal("MetaMapList_ScrollFrameButton"..i);
		local NameButton = getglobal("MetaMapList_ScrollFrameButton"..i.."Name");
		if buttonIndex < MetaMap_NoteList.lastEntry +1 then
			MetaMap_ListOffset = buttonIndex - i;
			NameButton:SetText(MetaMap_NoteList[buttonIndex]["name"]);
			getglobal("MetaMapList_ScrollFrameButton"..i.."NoteID"):SetText(MetaMap_NoteList[buttonIndex]["id"]);
			if(MetaMapOptions.ListColors) then
				local cNr = MetaMap_NoteList[buttonIndex]["ncol"]
				NameButton:SetTextColor(MetaMapNotes_Colors[cNr].r, MetaMapNotes_Colors[cNr].g, MetaMapNotes_Colors[cNr].b);
			else
				NameButton:SetTextColor(MetaMapNotes_Colors[0].r, MetaMapNotes_Colors[0].g, MetaMapNotes_Colors[0].b);
			end
			scrollFrameButton:Show();
		else
			scrollFrameButton:Hide();
		end
	end
	FauxScrollFrame_Update(MetaMapList_ScrollFrame, MetaMap_NoteList.lastEntry,
		METAMAPLIST_SCROLL_FRAME_BUTTONS_SHOWN, METAMAPLIST_SCROLL_FRAME_BUTTON_HEIGHT);
end

function MetaMapPing_SetPing(id)
	if(MetaMapPing:IsVisible()) then
		MetaMapPing:Hide();
		return;
	end
	local x, y = nil;
	if(id == 0) then
		MetaMapPing:SetParent(WorldMapButton);
		x, y = GetPlayerMapPosition("player");
	else
		local button = getglobal("MetaMapNotesPOI"..id);
		MetaMapPing:SetParent(button);
		x = MetaMap_NoteList[id]["xPos"];
		y = MetaMap_NoteList[id]["yPos"];
	end
	x = (x * WorldMapButton:GetWidth()) - (WorldMapPlayer:GetEffectiveScale() * 10);
	y = (-y * WorldMapButton:GetHeight()) - (WorldMapPlayer:GetEffectiveScale() * 10);
	MetaMapPing:SetPoint("CENTER", WorldMapButton, "TOPLEFT", x, y);
	MetaMapPing:SetAlpha(255);
	MetaMapPing.timer = MetaMap_PingTime;
	MetaMapPing:Show();
	PlaySound("MapPing");
end

function MetaMapPing_OnUpdate(elapsed)
	if(MetaMapPing:IsVisible()) then
		if ( MetaMapPing.timer > 0 ) then
			MetaMapPing.timer = MetaMapPing.timer - elapsed;
		else
			MetaMapPing:Hide();
		end
	end
end

function MetaMap_ZoneHeader()
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	MetaMapNotes_ZoneSearchResult:SetText(format(METAMAPNOTES_ZONESEARCH_TEXT, mapName));
	if(not MetaMapOptions.ZoneHeader) then
		MetaMap_ZoneHeaderFrame:Hide();
		return;
	end
	local realContinent, realZone = MetaMap_NameToZoneID(GetRealZoneText());
	if(realZone == nil) then realZone = 0; end
	continent = "|cfff0B300Map Continent: |cffffffff"..continent;
	zone = "   |cfff0B300Map Zone: |cffffffff"..mapName.." ("..zone..")";
	realContinent = "|cfff0B300Real Continent: |cffffffff"..realContinent;
	realZone = "   |cfff0B300Real Zone: |cffffffff"..GetRealZoneText().." ("..realZone..")";
	MetaMapZoneHeaderText1:SetText(continent..zone);
	MetaMapZoneHeaderText2:SetText(realContinent..realZone);
	MetaMap_ZoneHeaderFrame:SetWidth(WorldMapDetailFrame:GetWidth()-200);
	MetaMap_ZoneHeaderFrame:Show();
end

function MetaMap_LoadImports(mode)
	if(not IsAddOnLoaded("MetaMapCVT")) then
		LoadAddOn("MetaMapCVT");
	end
	if(IsAddOnLoaded("MetaMapCVT")) then
		if(mode == 1) then
			MetaKB_UpdateDB();
		else
			MetaMapCVT_CheckData();
		end
	else
		MetaMap_StatusPrint(METAMAPCVT_NOLOAD, true);
	end
end

function MetaMap_StatusPrint(msg, display, r, g, b)
	if(not display) then return; end
	msg = "<"..METAMAP_TITLE..">: "..msg;
	if DEFAULT_CHAT_FRAME then
		if(r == nil or g == nil or b == nil) then
			r = 0.60;
			g = 0.80;
			b = 1.00;
		end
		DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
	end
end

function MetaMapNotes_ChatFrame_OnEvent(...)
	local event = unpack(arg);
	if(strsub(event, 1, 16) == "CHAT_MSG_WHISPER" and strsub(arg1, 1, 6) == "<MapN>") then
		if arg2 == UnitName("player") then return; end
		MetaMapNotes_GetNoteFromChat(arg1, arg2);
	else
		orig_ChatFrame_OnEvent(unpack(arg));
	end
end

function MetaMap_CreateNoteObject(noteNumber)
	local button;
	if(getglobal("MetaMapNotesPOI"..noteNumber)) then
		button = getglobal("MetaMapNotesPOI"..noteNumber);
	else
		button = CreateFrame("Button" ,"MetaMapNotesPOI"..noteNumber);
		MetaMapNotes_LastNote = MetaMapNotes_LastNote +1;
	end
	button:SetID(noteNumber);
	button:SetWidth(MetaMapNotes_IconWidth);
	button:SetHeight(MetaMapNotes_IconHeight);
	button:CreateTexture("MetaMapNotesPOI"..noteNumber.."Texture", "BACKGROUND");
	getglobal("MetaMapNotesPOI"..noteNumber.."Texture"):SetWidth(button:GetWidth());
	getglobal("MetaMapNotesPOI"..noteNumber.."Texture"):SetHeight(button:GetHeight());
	getglobal("MetaMapNotesPOI"..noteNumber.."Texture"):SetPoint("CENTER", button, "CENTER", 0, 0);
	button:SetScript("OnLoad", function() this:RegisterForClicks("LeftButtonDown", "RightButtonDown"); this:SetFrameLevel(this:GetFrameLevel() +3); end)
	button:SetScript("OnEnter", function() MetaMapNotes_OnEnter(this:GetID()); end)
	button:SetScript("OnLeave", function() WorldMapTooltip:Hide(); end)
	button:SetScript("OnClick", function() MetaMapNotes_Note_OnClick(arg1,	this:GetID()); end)
	return button;
end

function MetaMap_CreateLineObject(lineNumber)
	local line;
	if(getglobal("MetaMapNotesLines_"..lineNumber)) then
		line = getglobal("MetaMapNotesLines_"..lineNumber);
	else
		MetaMapNotesLinesFrame:CreateTexture("MetaMapNotesLines_"..lineNumber, "ARTWORK");
		line = getglobal("MetaMapNotesLines_"..lineNumber);
		MetaMapNotes_LastLine = MetaMapNotes_LastLine +1;
	end
	return line
end

function MetaMapNotes_AddNewNote(continent, zone, xPos, yPos, name, inf1, inf2, creator, icon, ncol, in1c, in2c, mininote)
	if(type(continent) == "string") then
		MetaMap_StatusPrint(METAMAPNOTES_INVALIDZONE, true);
		return;
	end
	if(continent == nil or zone == nil or xPos == nil or yPos == nil or name == nil) then return; end
	if(inf1 == nil) then inf1 = ""; end
	if(inf2 == nil) then inf2 = ""; end
	if(icon == nil) then icon = 0; end
	if(ncol == nil) then ncol = 0; end
	if(in1c == nil) then in1c = 0; end
	if(in2c == nil) then in2c = 0; end
	if(creator == nil) then creator = unitName("player"); end
	local id = 0;
	local checkNote;
	local returnValue = true;
	local currentZone = MetaMapNotes_Data[continent][zone];
	local index = MetaMapNotes_GetZoneTableSize(currentZone);

	if(mininote == 0 or mininote == nil) then
		MetaMapNotes_SetNextAsMiniNote = 0;
	elseif(mininote == 1) then
		MetaMapNotes_SetNextAsMiniNote = 1;
	elseif(mininote == 2) then
		MetaMapNotes_SetNextAsMiniNote = 2;
	end		

	if(MetaMapNotes_SetNextAsMiniNote ~= 2) then
		checkNote = MetaMapNotes_CheckNearNotes(continent, zone, xPos, yPos);
		if(checkNote) then
			returnValue = false;
		else
			MetaMapNotes_TempData_Id = index + 1
			currentZone[MetaMapNotes_TempData_Id] = {};
			currentZone[MetaMapNotes_TempData_Id].name = name;
			currentZone[MetaMapNotes_TempData_Id].ncol = ncol;
			currentZone[MetaMapNotes_TempData_Id].inf1 = inf1;
			currentZone[MetaMapNotes_TempData_Id].in1c = in1c;
			currentZone[MetaMapNotes_TempData_Id].inf2 = inf2;
			currentZone[MetaMapNotes_TempData_Id].in2c = in2c;
			currentZone[MetaMapNotes_TempData_Id].creator = creator;
			currentZone[MetaMapNotes_TempData_Id].icon = icon;
			currentZone[MetaMapNotes_TempData_Id].xPos = xPos;
			currentZone[MetaMapNotes_TempData_Id].yPos = yPos;
			id = MetaMapNotes_TempData_Id;
			if(MetaMapNotes_MiniNote_Data ~= nil and MetaMapNotes_MiniNote_Data.name == name) then
				MetaMapNotes_MiniNote_Data.id = id;
			end
			returnValue = true;
		end
	end
	if(MetaMapNotes_SetNextAsMiniNote ~= 0) then
		for i=0, index, 1 do
		if(currentZone[i] ~= nil) then
			if(currentZone[i].name == name) then
				id = i;
			end
		end
		end
		MetaMapNotes_SetMiniNote(id, continent, zone, xPos, yPos, name, inf1, inf2, creator, icon, ncol, in1c, in2c);
		returnValue = returnValue;
	end
	return returnValue, checkNote;
end

function MetaMapNotes_SetMiniNote(id, continent, zone, xPos, yPos, name, inf1, inf2, creator, icon, ncol, in1c, in2c)
	if(type(continent) == "string") then
		MetaMap_StatusPrint(METAMAPNOTES_INVALIDZONE, true);
		return;
	end
	local currentZone;
	local mapName = MetaMap_ZoneNames[continent][zone];

	MetaMapNotes_MiniNote_Data.id = id;
	MetaMapNotes_MiniNote_Data.continent = continent;
	MetaMapNotes_MiniNote_Data.zone = zone;
	MetaMapNotes_MiniNote_Data.zonetext = mapName;
	MetaMapNotes_MiniNote_Data.inf1 = "";
	MetaMapNotes_MiniNote_Data.inf2 = "";
	MetaMapNotes_MiniNote_Data.in1c = 1;
	MetaMapNotes_MiniNote_Data.in2c = 1;
	MetaMapNotes_MiniNote_Data.color = 0;
	MetaMapNotes_MiniNote_Data.creator = creator;
	if(id == 0) then
		MetaMapNotes_MiniNote_Data.xPos = xPos;
		MetaMapNotes_MiniNote_Data.yPos = yPos;
		MetaMapNotes_MiniNote_Data.name = name;
		MetaMapNotes_MiniNote_Data.inf1 = inf1;
		MetaMapNotes_MiniNote_Data.inf2 = inf2;
		MetaMapNotes_MiniNote_Data.in1c = in1c;
		MetaMapNotes_MiniNote_Data.in2c = in2c;
		MetaMapNotes_MiniNote_Data.color = ncol;
		MetaMapNotes_MiniNote_Data.icon = icon;
	elseif(id == -1) then
		MetaMapNotes_MiniNote_Data.xPos = MetaMapNotes_PartyNoteData.xPos;
		MetaMapNotes_MiniNote_Data.yPos = MetaMapNotes_PartyNoteData.yPos;
		MetaMapNotes_MiniNote_Data.name = METAMAPNOTES_PARTYNOTE;
		MetaMapNotes_MiniNote_Data.icon = "party";
	elseif(id > 0) then
		currentZone = MetaMapNotes_Data[continent][zone][id];
		MetaMapNotes_MiniNote_Data.xPos = currentZone.xPos;
		MetaMapNotes_MiniNote_Data.yPos = currentZone.yPos;
		MetaMapNotes_MiniNote_Data.name = currentZone.name;
		MetaMapNotes_MiniNote_Data.inf1 = currentZone.inf1;
		MetaMapNotes_MiniNote_Data.inf2 = currentZone.inf2;
		MetaMapNotes_MiniNote_Data.in1c = currentZone.in1c;
		MetaMapNotes_MiniNote_Data.in2c = currentZone.in2c;
		MetaMapNotes_MiniNote_Data.color = currentZone.ncol;
		MetaMapNotes_MiniNote_Data.icon = currentZone.icon;
		MetaMapNotes_MiniNote_Data.creator = currentZone.creator;
	end
	MiniNotePOITexture:SetTexture(METAMAP_ICON_PATH.."Icon"..MetaMapNotes_MiniNote_Data.icon);
	MiniNotePOI:Show();
	MetaMapNotes_SetNextAsMiniNote = 0;
	MetaMapNotesButtonMiniNoteOff:Enable();
	MetaMapNotes_MapUpdate();
end

function MetaMapNotes_CheckNearNotes(continent, zone, xPos, yPos)
	local currentZone = MetaMapNotes_Data[continent][zone];
	local i = 1;
	for j, value in currentZone do
		local deltax = abs(currentZone[i].xPos - xPos);
		local deltay = abs(currentZone[i].yPos - yPos);
		if(deltax <= 0.0009765625 * MetaMapNotes_MinDiff and deltay <= 0.0013020833 * MetaMapNotes_MinDiff) then
			return i;
		end
		i = i + 1;
	end
	return false;
end

function MetaMapNotes_GenerateSendString(version)
-- <MapN> c<1> z<1> x<0.123123> y<0.123123> t<> i1<> i2<> cr<> i<8> tf<3> i1f<5> i2f<6>
	local text = ""
	local pName = UnitName("player");
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	if(not currentZone) then return; end
	if(version == 1) then text = "<MapN>"; end
	text = text.." c<"..continent.."> z<"..zone..">";

	if(MetaMapNotes_PartyNoteSet) then
		local xPos = floor(MetaMapNotes_PartyNoteData.xPos * 1000000)/1000000;
		local yPos = floor(MetaMapNotes_PartyNoteData.yPos * 1000000)/1000000;
		text = text.." x<"..xPos.."> y<"..yPos..">";
		text = text.." t<"..METAMAPNOTES_PARTYNOTE..">";
		text = text.." i1<>";
		text = text.." i2<>";
		text = text.." cr<"..pName..">";
		text = text.." i<0>";
		text = text.." tf<0>";
		text = text.." i1f<0>";
		text = text.." i2f<0>";
		text = text.." p<1>";
	elseif(MetaMapNotes_MiniNote_Data.id == 0) then
		local xPos = floor(MetaMapNotes_MiniNote_Data.xPos * 1000000)/1000000;
		local yPos = floor(MetaMapNotes_MiniNote_Data.yPos * 1000000)/1000000;
		text = text.." x<"..xPos.."> y<"..yPos..">";
		text = text.." t<"..MetaMapNotes_EliminateUsedChars(MetaMapNotes_MiniNote_Data.name)..">";
		text = text.." i1<"..MetaMapNotes_EliminateUsedChars(MetaMapNotes_MiniNote_Data.inf1)..">";
		text = text.." i2<"..MetaMapNotes_EliminateUsedChars(MetaMapNotes_MiniNote_Data.inf2)..">";
		text = text.." cr<"..MetaMapNotes_MiniNote_Data.creator..">";
		text = text.." i<"..MetaMapNotes_MiniNote_Data.icon..">";
		text = text.." tf<"..MetaMapNotes_MiniNote_Data.color..">";
		text = text.." i1f<"..MetaMapNotes_MiniNote_Data.in1c..">";
		text = text.." i2f<"..MetaMapNotes_MiniNote_Data.in2c..">";
	else
		if(not currentZone[MetaMapNotes_TempData_Id].creator) then
			currentZone[MetaMapNotes_TempData_Id].creator = pName;
		end
		local xPos = floor(currentZone[MetaMapNotes_TempData_Id].xPos * 1000000)/1000000; --cut to six digits behind the 0
		local yPos = floor(currentZone[MetaMapNotes_TempData_Id].yPos * 1000000)/1000000;
		text = text.." x<"..xPos.."> y<"..yPos..">";
		text = text.." t<"..MetaMapNotes_EliminateUsedChars(currentZone[MetaMapNotes_TempData_Id].name)..">";
		text = text.." i1<"..MetaMapNotes_EliminateUsedChars(currentZone[MetaMapNotes_TempData_Id].inf1)..">";
		text = text.." i2<"..MetaMapNotes_EliminateUsedChars(currentZone[MetaMapNotes_TempData_Id].inf2)..">";
		text = text.." cr<"..currentZone[MetaMapNotes_TempData_Id].creator..">";
		text = text.." i<"..currentZone[MetaMapNotes_TempData_Id].icon..">";
		text = text.." tf<"..currentZone[MetaMapNotes_TempData_Id].ncol..">";
		text = text.." i1f<"..currentZone[MetaMapNotes_TempData_Id].in1c..">";
		text = text.." i2f<"..currentZone[MetaMapNotes_TempData_Id].in2c..">";
	end
	MetaMapNotes_PartyNoteSet = false;
	return text;
end

function MetaMapNotes_EliminateUsedChars(text)
	text = string.gsub(text, "<", "")
	text = string.gsub(text, ">", "")
	return text
end

function MetaMapNotes_GetSendString(msg, who)
	local continent = gsub(msg,".*<MapN+> c<([^>]*)>.*","%1",1)+0;
	local zone = gsub(msg,".*<MapN+>%s+%w+.*z<([^>]*)>.*","%1",1)+0;
	local xPos = gsub(msg,".*<MapN+>%s+%w+.*x<([^>]*)>.*","%1",1)+0;
	local yPos = gsub(msg,".*<MapN+>%s+%w+.*y<([^>]*)>.*","%1",1)+0;
	local name = gsub(msg,".*<MapN+>%s+%w+.*t<([^>]*)>.*","%1",1);
	local inf1 = gsub(msg,".*<MapN+>%s+%w+.*i1<([^>]*)>.*","%1",1);
	local inf2 = gsub(msg,".*<MapN+>%s+%w+.*i2<([^>]*)>.*","%1",1);
	local creator = gsub(msg,".*<MapN+>%s+%w+.*cr<([^>]*)>.*","%1",1);
	local icon = gsub(msg,".*<MapN+>%s+%w+.*i<([^>]*)>.*","%1",1)+0;
	local ncol = gsub(msg,".*<MapN+>%s+%w+.*tf<([^>]*)>.*","%1",1)+0;
	local in1c = gsub(msg,".*<MapN+>%s+%w+.*i1f<([^>]*)>.*","%1",1)+0;
	local in2c = gsub(msg,".*<MapN+>%s+%w+.*i2f<([^>]*)>.*","%1",1)+0;
	local setNote, nearNote = MetaMapNotes_AddNewNote(continent, zone, xPos, yPos, name, inf1, inf2, creator, icon, ncol, in1c, in2c, MetaMapNotes_SetNextAsMiniNote);
	if(who == nil) then
		if(setNote) then
			MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_NOTE, MetaMap_ZoneNames[continent][zone]), true);
		else
			MetaMap_StatusPrint(format(METAMAPNOTES_DECLINE_NOTE, MetaMapNotes_Data[continent][zone][nearNote].name, MetaMap_ZoneNames[continent][zone]), true);
		end
	else
		if(setNote) then
			MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_GET, who, MetaMap_ZoneNames[continent][zone]), true);
		else
			MetaMap_StatusPrint(format(METAMAPNOTES_DECLINE_GET, who, MetaMap_ZoneNames[continent][zone], MetaMapNotes_Data[continent][zone][nearNote].name), true);
		end
	end
	return setNote;
end

function MetaMapNotes_Quicknote(msg)
	local continent, zone = MetaMap_NameToZoneID(GetRealZoneText())
	if(type(continent) == "string") then
		MetaMap_StatusPrint(METAMAPNOTES_INVALIDZONE, true);
		return;
	end
	local currentZone = MetaMapNotes_Data[continent][zone];
	local name = METAMAPNOTES_QUICKNOTE_DEFAULTNAME;
	if(msg ~= "" and msg ~= nil) then
		if(strlen(msg) == 1) then
			mode = tonumber(strsub(msg, 1, 1));
			msg = "";
		else
			local mCheck = strsub(msg, 1, 2);
			if(mCheck == "1 " or mCheck == "2 " or mCheck == "3 ") then
				mode = tonumber(strsub(msg, 1, 1));
				msg = strsub(msg, 3);
			else
				mode = MetaMapNotes_SetNextAsMiniNote;
			end
		end
	else
		mode = MetaMapNotes_SetNextAsMiniNote;
	end
	local i,j,x,y,tmp = string.find(msg,"%s*(%d+)%s*[,.]%s*(%d+)%s*([^%c]*)");
	if(x == nil or y == nil) then
		SetMapToCurrentZone();
		x, y = GetPlayerMapPosition("player");
	else
		x = x / 100;
		y = y / 100;
		msg = tmp;
	end
	if(mode == 3) then
		MetaMapNotes_vnote_xPos = x;
		MetaMapNotes_vnote_yPos = y;
		MetaMap_StatusPrint(METAMAPNOTES_VNOTE_SET, true);
		return;
	end
	if msg ~= "" and msg ~= nil then
		name = string.sub(msg,string.find(msg,"%s*([^%c]*)"));
	end
	local checkNote, nearNote = MetaMapNotes_AddNewNote(continent, zone, x, y, name, "", "", UnitName("player"), 0, 0, 0, 0, mode);
	if(checkNote) then
		if(mode ~= 2) then
			MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_NOTE, GetRealZoneText()), true);
		end
	else
		MetaMap_StatusPrint(format(METAMAPNOTES_DECLINE_NOTE, currentZone[nearNote].name, GetRealZoneText()), true);
	end
	if(mode > 0) then
		MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_MININOTE, GetRealZoneText()), true);
	end
	MetaMapNotes_Qnote = false;
end

function MetaMapNotes_QuickNoteShow()
	local x, y = GetPlayerMapPosition("player");
	x = MetaMap_round(x*100);
	y = MetaMap_round(y*100);
	Coords_EditBox:SetText(x..","..y);
	MiniNote_CheckButton:SetChecked(false);
	MetaMapNotes_Qnote = true;
end

function MetaMapNotes_SetQuickNote(mode)
	local msg;
	if(mode == 1) then
		msg = Coords_EditBox:GetText().." "..Note_EditBox:GetText();
	else
		msg = "3 "..Coords_EditBox:GetText();
	end
	MetaMapNotes_Quicknote(msg);
end

function MetaMapNotes_GetNoteFromChat(msg, who)
	if(MetaMapNotes_Options[14] == "off") then
		MetaMap_StatusPrint(format(METAMAPNOTES_DISABLED_GET, who), true)
		return;
	end
	if(gsub(msg,".*<MapN+>%s+%w+.*p<([^>]*)>.*","%1",1) == "1") then -- Party Note
		local id = -1;
		local continent = gsub(msg,".*<MapN+> c<([^>]*)>.*","%1",1)+0;
		local zone = gsub(msg,".*<MapN+>%s+%w+.*z<([^>]*)>.*","%1",1)+0;
		local xPos = gsub(msg,".*<MapN+>%s+%w+.*x<([^>]*)>.*","%1",1)+0;
		local yPos = gsub(msg,".*<MapN+>%s+%w+.*y<([^>]*)>.*","%1",1)+0;
		local icon = "party";
		MetaMapNotes_PartyNoteData.continent = continent;
		MetaMapNotes_PartyNoteData.zone = zone;
		MetaMapNotes_PartyNoteData.xPos = xPos;
		MetaMapNotes_PartyNoteData.yPos = yPos;
		if(MetaMapNotes_Options[16] ~= "off") then
			MetaMapNotes_SetMiniNote(id, continent, zone, xPos, yPos, name, inf1, inf2, creator, icon, ncol, in1c, in2c);
			MetaMap_StatusPrint(format(METAMAPNOTES_PARTY_GET, who, MetaMap_ZoneNames[continent][zone]), true)
		end
	else
		MetaMapNotes_GetSendString(msg, who);
	end
end

function MetaMapNotes_GetNoteBySlashCommand(msg)
	if msg ~= "" and msg ~= nil then
		msg = "<MapN> "..msg;
		return MetaMapNotes_GetSendString(msg);
	else
		MetaMap_StatusPrint(METAMAPNOTES_MAPNOTEHELP, true);
		return false;
	end
end

function MetaMapNotes_Misc_OnClick(button)
	if(not MetaMapNotes_FramesHidden()) then return; end
	if button == "LeftButton" then
		if(this:GetID() == 0) then
			MetaMapNotes_TempData_Id = 0;
			MetaMapNotes_OpenEditForExistingNote(MetaMapNotes_TempData_Id);
		elseif(this:GetID() == 1) then
			MetaMapNotes_PartyNoteSet = true;
			MetaMapNotes_TempData_Id = -1;
			MetaMapNotes_ShowSendFrame(1);
		end
	end
end

function MetaMapNotes_NextMiniNote(msg)
	msg = string.lower(msg)
	if msg == "on" then
		MetaMapNotes_SetNextAsMiniNote = 1
	elseif msg == "off" then
		MetaMapNotes_SetNextAsMiniNote = 0
	elseif MetaMapNotes_SetNextAsMiniNote == 1 then
		MetaMapNotes_SetNextAsMiniNote = 0
	else
		MetaMapNotes_SetNextAsMiniNote = 1
	end
end

function MetaMapNotes_NextMiniNoteOnly(msg)
	msg = string.lower(msg)
	if msg == "on" then
		MetaMapNotes_SetNextAsMiniNote = 2
	elseif msg == "off" then
		MetaMapNotes_SetNextAsMiniNote = 0
	elseif MetaMapNotes_SetNextAsMiniNote == 2 then
		MetaMapNotes_SetNextAsMiniNote = 0
	else
		MetaMapNotes_SetNextAsMiniNote = 2
	end
end

function MetaMapNotes_MinimapUpdateZoom()
	if MetaMapNotes_MiniNote_MapzoomInit then
		if MetaMapNotes_MiniNote_IsInCity then
			MetaMapNotes_MiniNote_IsInCity = false
		else
			MetaMapNotes_MiniNote_IsInCity = true
		end
	else
		local tempzoom = 0
		if GetCVar("minimapZoom") == GetCVar("minimapInsideZoom") then
			if GetCVar("minimapInsideZoom")+0 >= 3 then
				Minimap:SetZoom(Minimap:GetZoom() - 1)
				tempzoom = 1
			else
				Minimap:SetZoom(Minimap:GetZoom() + 1)
				tempzoom = -1
			end
		end

		if GetCVar("minimapInsideZoom")+0 == Minimap:GetZoom() then
			MetaMapNotes_MiniNote_IsInCity = true
		else
			MetaMapNotes_MiniNote_IsInCity = false
		end

		Minimap:SetZoom(Minimap:GetZoom() + tempzoom)
		MetaMapNotes_MiniNote_MapzoomInit = true
	end
end

function MetaMapNotes_MiniNote_OnUpdate(delay)
	if(MetaMapNotes_MiniNote_Data.xPos == nil or GetRealZoneText() ~= MetaMapNotes_MiniNote_Data.zonetext) then
		MiniNotePOI:Hide();
		return;
	end
	local continent, zone = MetaMap_NameToZoneID(GetRealZoneText());
	if(zone ~= GetCurrentMapZone()) then
		return;
	end
		MiniNotePOI.TimeSinceLastUpdate = MiniNotePOI.TimeSinceLastUpdate + delay;
		if MiniNotePOI.TimeSinceLastUpdate >= MetaMapNotes_Mininote_UpdateRate then
			local x, y = GetPlayerMapPosition("player");
			if x == 0 and y == 0 then
				MiniNotePOI:Hide()
				return
			end

			local currentConst
			if(type(continent) == "string") then
				currentConst = MetaMapNotes_Const[continent]
			elseif continent > 0 and MetaMapNotes_MiniNote_Data.continent > 0 then
				local c = MetaMapNotes_MiniNote_Data.continent
				local z = MetaMapNotes_MiniNote_Data.zone
				currentConst = MetaMapNotes_Const[c][z]
			else
				MiniNotePOI:Hide();
				return;
			end

			local currentZoom = Minimap:GetZoom()

			if currentConst and x ~= 0 and y ~= 0 and currentConst.scale ~= 0 then
				local xscale,yscale
				if zone > 0 then
					xscale = MetaMapNotes_Const[MetaMapNotes_MiniNote_Data.continent][currentZoom].xscale
					yscale = MetaMapNotes_Const[MetaMapNotes_MiniNote_Data.continent][currentZoom].yscale
				else
					xscale = MetaMapNotes_Const[2][currentZoom].xscale
					yscale = MetaMapNotes_Const[2][currentZoom].yscale
				end

				if MetaMapNotes_MiniNote_IsInCity then
					xscale = xscale * MetaMapNotes_Const[2][currentZoom].cityscale
					yscale = yscale * MetaMapNotes_Const[2][currentZoom].cityscale
				end
				local xpos = MetaMapNotes_MiniNote_Data.xPos * currentConst.scale + currentConst.xoffset
				local ypos = MetaMapNotes_MiniNote_Data.yPos * currentConst.scale + currentConst.yoffset
				x = x * currentConst.scale + currentConst.xoffset
				y = y * currentConst.scale + currentConst.yoffset
				local deltax = (xpos - x) * xscale
				local deltay = (ypos - y) * yscale
				if sqrt( (deltax * deltax) + (deltay * deltay) ) > 56.5 then
					local adjust = 1
					if deltax == 0 then
						deltax = deltax + 0.0000000001
					elseif deltax < 0 then
						adjust = -1
					end
					local m = math.atan(deltay / deltax)
					deltax = math.cos(m) * 57 * adjust
					deltay = math.sin(m) * 57 * adjust
				end

				MiniNotePOI:SetPoint("CENTER", "MinimapCluster", "TOPLEFT", 105 + deltax, -93 - deltay)
				MiniNotePOI:Show()
			else
				MiniNotePOI:Hide()
			end
		end
		MiniNotePOI.TimeSinceLastUpdate = 0
end

function MetaMapNotes_MiniNote_OnClick(arg1)
	if(arg1 == "LeftButton" and IsShiftKeyDown() and ChatFrameEditBox:IsVisible()) then
		local x = MetaMap_round(MetaMapNotes_MiniNote_Data.xPos *100);
		local y = MetaMap_round(MetaMapNotes_MiniNote_Data.yPos *100);
		local msg = MetaMapNotes_MiniNote_Data.name.." ("..GetRealZoneText().." - "..x..","..y..")";
		ChatFrameEditBox:Insert(msg);
	else
		if(MetaMapNotes_MiniNote_Data.id > 0) then
			SetMapToCurrentZone();
			if(not WorldMapFrame:IsVisible()) then
				MetaMapNotesEditFrame:SetParent("UIParent");
			end
			MetaMapNotes_OpenEditForExistingNote(MetaMapNotes_MiniNote_Data.id);
		elseif(MetaMapNotes_MiniNote_Data.id == 0) then
			MetaMapNotes_TempData_Id = 0;
			MetaMapNotes_ShowSendFrame(0);
		else
			MetaMapNotes_PartyNoteSet = true;
			MetaMapNotes_TempData_Id = -1;
			MetaMapNotes_ShowSendFrame(1);
		end
	end
end

function MetaMapNotes_ShowNewFrame(ax, ay)
	if(not MetaMapNotes_FramesHidden()) then return; end
	local width = WorldMapButton:GetWidth();
	local height = WorldMapButton:GetHeight();
	local xOffset,yOffset;
	MetaMapNotes_TempData_xPos = ax;
	MetaMapNotes_TempData_yPos = ay;
	MetaMapNotes_TempData_Id = nil;
	if ax*1002 >= (1002 - 195) then
		xOffset = ax * width - 176;
	else
		xOffset = ax * width;
	end
	if ay*668 <= (668 - 156) then
		yOffset = -(ay * height) - 75;
		else
		yOffset = -(ay * height) + 87;
	end
	MetaMapNotesButtonMiniNoteOff:Disable();
	MetaMapNotesButtonMiniNoteOn:Disable();
	MetaMapNotesButtonDeleteNote:Disable();
	MetaMapNotesButtonToggleLine:Disable();
	MetaMapNotesButtonSendNote:Disable();
	MetaMapNotesButtonMoveNote:Disable();
	MetaMapNotesEditFrameTitle:SetText(METAMAPNOTES_NEW_NOTE);
	MetaMapNotes_OpenEditForNewNote();
end

function MetaMapNotes_OpenEditForNewNote()
	if MetaMapNotes_TempData_Id == 0 then
		MetaMapNotes_vnote_xPos = nil
		MetaMapNotes_vnote_yPos = nil
	end
	MetaMapNotes_TempData_Id = MetaMapNotes_NewNoteSlot()
	MetaMapNotes_TempData_Creator = UnitName("player")
	MetaMapNotes_Edit_SetIcon(0)
	MetaMapNotes_Edit_SetTextColor(0)
	MetaMapNotes_Edit_SetInfo1Color(0)
	MetaMapNotes_Edit_SetInfo2Color(0)
	TitleWideEditBox:SetText("")
	Info1WideEditBox:SetText("")
	Info2WideEditBox:SetText("")
	CreatorWideEditBox:SetText(MetaMapNotes_TempData_Creator)
	MetaMapNotes_HideAll()
	MetaMapNotesEditFrame:Show()
end

function MetaMapNotes_OpenEditForExistingNote(id)
	MetaMapNotes_HideAll();
	MetaMapNotesEditFrameTitle:SetText(METAMAPNOTES_EDIT_NOTE);
	if(MetaMapNotes_MiniNote_Data.xPos == nil) then
		MetaMapNotesButtonMiniNoteOff:Disable();
	else
		MetaMapNotesButtonMiniNoteOff:Enable();
	end
	MetaMapNotesButtonMiniNoteOn:Enable();
	MetaMapNotesButtonDeleteNote:Enable();
	MetaMapNotesButtonToggleLine:Enable();
	MetaMapNotesButtonMoveNote:Enable();

	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	MetaMapNotes_TempData_Id = id

	if(id == 0) then
		WorldMapTooltip:Hide();
		MetaMapNotes_ShowNewFrame(MetaMapNotes_vnote_xPos, MetaMapNotes_vnote_yPos);
		return;
	elseif(id == -1) then
		WorldMapTooltip:Hide();
		MetaMapNotes_ShowNewFrame(MetaMapNotes_PartyNoteData.xPos, MetaMapNotes_PartyNoteData.yPos);
		return;
	end
	MetaMapNotes_TempData_LootID = nil;
	if(currentZone[MetaMapNotes_TempData_Id].lootid ~= nil)then
		MetaMapNotes_TempData_LootID = currentZone[MetaMapNotes_TempData_Id].lootid
	end
	MetaMapNotes_TempData_Creator = currentZone[MetaMapNotes_TempData_Id].creator
	MetaMapNotes_TempData_xPos = currentZone[MetaMapNotes_TempData_Id].xPos
	MetaMapNotes_TempData_yPos = currentZone[MetaMapNotes_TempData_Id].yPos
	MetaMapNotes_Edit_SetIcon(currentZone[MetaMapNotes_TempData_Id].icon)
	MetaMapNotes_Edit_SetTextColor(currentZone[MetaMapNotes_TempData_Id].ncol)
	MetaMapNotes_Edit_SetInfo1Color(currentZone[MetaMapNotes_TempData_Id].in1c)
	MetaMapNotes_Edit_SetInfo2Color(currentZone[MetaMapNotes_TempData_Id].in2c)
	TitleWideEditBox:SetText(currentZone[MetaMapNotes_TempData_Id].name)
	Info1WideEditBox:SetText(currentZone[MetaMapNotes_TempData_Id].inf1)
	Info2WideEditBox:SetText(currentZone[MetaMapNotes_TempData_Id].inf2)
	CreatorWideEditBox:SetText(currentZone[MetaMapNotes_TempData_Id].creator)
	MetaMapNotesEditFrame:Show()
end

function MetaMapNotes_ShowSendFrame(number)
	MetaMapNotesSendPlayer:Enable();
	MetaMapNotesSendParty:Enable();
	MetaMapNotesChangeSendFrame:Enable();
	SendWideEditBox:Show();
	MetaMapNotes_SendFrame_Player:Show();
	if(number == 0) then
		MetaMapNotesDeletePartyNote:Show();
		MetaMapNotes_ToggleSendValue = 2;
	elseif(number == 1) then
		if(MetaMapNotes_PartyNoteSet) then
			MetaMapNotesDeletePartyNote:Show();
			MetaMapNotesSendPlayer:Disable();
			MetaMapNotesChangeSendFrame:Disable();
			SendWideEditBox:Hide();
			MetaMapNotes_SendFrame_Player:Hide();
		end
		MetaMapNotesChangeSendFrame:SetText(METAMAPNOTES_SLASHCOMMAND);
		SendWideEditBox:SetText("");
		if(UnitCanCooperate("player", "target")) then
			SendWideEditBox:SetText(UnitName("target"));
		end
			MetaMapNotes_SendFrame_Title:SetText(METAMAPNOTES_SEND_NOTE);
			MetaMapNotes_SendFrame_Tip:SetText(METAMAPNOTES_SEND_TIP);
			MetaMapNotes_SendFrame_Player:SetText(METAMAPNOTES_SEND_PLAYER);
			MetaMapNotes_ToggleSendValue = 2;
	elseif(number == 2) then
		MetaMapNotesChangeSendFrame:SetText(METAMAPNOTES_SHOWSEND);
		SendWideEditBox:SetText("/mapnote"..MetaMapNotes_GenerateSendString(2));
		MetaMapNotes_SendFrame_Title:SetText(METAMAPNOTES_SEND_SLASHTITLE);
		MetaMapNotes_SendFrame_Tip:SetText(METAMAPNOTES_SEND_SLASHTIP);
		MetaMapNotes_SendFrame_Player:SetText(METAMAPNOTES_SEND_SLASHCOMMAND);
		MetaMapNotes_ToggleSendValue = 1;
	end
	if(not MetaMapNotesSendFrame:IsVisible()) then
		MetaMapNotes_HideAll();
		MetaMapNotesSendFrame:Show();
	end
end

function MetaMapNotes_Edit_SetIcon(icon)
	MetaMapNotes_TempData_Icon = icon;
	IconOverlay:SetPoint("TOPLEFT", "EditIcon"..icon, "TOPLEFT", -3, 3);
end

function MetaMapNotes_Edit_SetTextColor(color)
	MetaMapNotes_TempData_TextColor = color
	TextColorOverlay:SetPoint("TOPLEFT", "TextColor"..color, "TOPLEFT", -3, 3)
end

function MetaMapNotes_Edit_SetInfo1Color(color)
	MetaMapNotes_TempData_Info1Color = color
	Info1ColorOverlay:SetPoint("TOPLEFT", "Info1Color"..color, "TOPLEFT", -3, 3)
end

function MetaMapNotes_Edit_SetInfo2Color(color)
	MetaMapNotes_TempData_Info2Color = color
	Info2ColorOverlay:SetPoint("TOPLEFT", "Info2Color"..color, "TOPLEFT", -3, 3)
end

function MetaMapNotes_SendNote(type)
	if(type == 1) then
		SendChatMessage(MetaMapNotes_GenerateSendString(1), "WHISPER", this.language, SendWideEditBox:GetText())
	elseif(type == 2) then
		local name;
		if(GetNumRaidMembers() > 0 ) then
			for i=1, GetNumRaidMembers(), 1 do
				name = GetRaidRosterInfo(i);
				if(name ~= UnitName("player")) then
					SendChatMessage(MetaMapNotes_GenerateSendString(1), "WHISPER", this.language, name)
				end
			end
			MetaMap_StatusPrint(METAMAPNOTES_RAIDSENT, true);
		elseif(GetNumPartyMembers() > 0) then
			for i=1, GetNumPartyMembers(), 1 do
				name = UnitName("party"..i);
				if(name ~= UnitName("player")) then
					SendChatMessage(MetaMapNotes_GenerateSendString(1), "WHISPER", this.language, name)
				end
			end
			MetaMap_StatusPrint(METAMAPNOTES_PARTYSENT, true);
		else
			MetaMap_StatusPrint(METAMAPNOTES_NOPARTY, true);
		end
	end
	MetaMapNotes_HideAll()
end

function MetaMapNotes_OpenOptionsFrame()
	for i=0, 16, 1 do
		if MetaMapNotes_Options[i] ~= "off" then
			getglobal("MetaMapNotesOptionsCheckbox"..i):SetChecked(1);
		else
			getglobal("MetaMapNotesOptionsCheckbox"..i):SetChecked(0);
		end
	end
	UIDropDownMenu_ClearAll(MetaMap_DeleteNotesList);
	UIDropDownMenu_Initialize(MetaMap_DeleteNotesList, MetaMap_DeleteNotesListInit, "MENU");
end

function MetaMapNotes_WriteOptions()
	for i=0, 16, 1 do
		if getglobal("MetaMapNotesOptionsCheckbox"..i):GetChecked() then
			MetaMapNotes_Options[i] = nil;
		else
			MetaMapNotes_Options[i] = "off";
		end
	end
	MetaMapNotes_MapUpdate();
end

function MetaMapNotes_ClearMiniNote(skipMapUpdate)
	MetaMapNotes_MiniNote_Data = {};
	if(MetaMapNotes_PartyNoteData ~= nil) then
		MetaMapNotes_DeleteNote(-1)
	end
	MiniNotePOI:Hide();
	MetaMapNotesButtonMiniNoteOff:Disable();
	if not skipMapUpdate then
		MetaMapNotes_MapUpdate();
	end
end

function MetaMapNotes_WriteNote()
	MetaMapNotes_HideAll();
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	if(not currentZone) then return; end

	currentZone[MetaMapNotes_TempData_Id] = {};
	currentZone[MetaMapNotes_TempData_Id].name = TitleWideEditBox:GetText();
	currentZone[MetaMapNotes_TempData_Id].ncol = MetaMapNotes_TempData_TextColor;
	currentZone[MetaMapNotes_TempData_Id].inf1 = Info1WideEditBox:GetText();
	currentZone[MetaMapNotes_TempData_Id].in1c = MetaMapNotes_TempData_Info1Color;
	currentZone[MetaMapNotes_TempData_Id].inf2 = Info2WideEditBox:GetText();
	currentZone[MetaMapNotes_TempData_Id].in2c = MetaMapNotes_TempData_Info2Color;
	currentZone[MetaMapNotes_TempData_Id].creator = CreatorWideEditBox:GetText();
	currentZone[MetaMapNotes_TempData_Id].icon = MetaMapNotes_TempData_Icon;
	currentZone[MetaMapNotes_TempData_Id].xPos = MetaMapNotes_TempData_xPos;
	currentZone[MetaMapNotes_TempData_Id].yPos = MetaMapNotes_TempData_yPos;
	if(MetaMapNotes_TempData_LootID ~= nil)then
		currentZone[MetaMapNotes_TempData_Id].lootid = MetaMapNotes_TempData_LootID;
		MetaMapNotes_TempData_LootID = nil;
	end

	if(continent == MetaMapNotes_MiniNote_Data.continent and MetaMapNotes_MiniNote_Data.zone == zone and MetaMapNotes_MiniNote_Data.id == MetaMapNotes_TempData_Id) then
		MetaMapNotes_MiniNote_Data.zonetext = mapName;
		MetaMapNotes_MiniNote_Data.name = TitleWideEditBox:GetText();
		MetaMapNotes_MiniNote_Data.icon = MetaMapNotes_TempData_Icon;
		MiniNotePOITexture:SetTexture(METAMAP_ICON_PATH.."Icon"..MetaMapNotes_MiniNote_Data.icon);
		MetaMapNotes_MiniNote_Data.inf1 = Info1WideEditBox:GetText();
		MetaMapNotes_MiniNote_Data.inf2 = Info2WideEditBox:GetText();
		MetaMapNotes_MiniNote_Data.in1c = MetaMapNotes_TempData_Info1Color;
		MetaMapNotes_MiniNote_Data.in2c = MetaMapNotes_TempData_Info2Color;
		MetaMapNotes_MiniNote_Data.color = MetaMapNotes_TempData_TextColor;
		MetaMapNotes_MiniNote_Data.creator = CreatorWideEditBox:GetText();
	end

	if(MetaMapNotes_vnote_xPos == MetaMapNotes_TempData_xPos and MetaMapNotes_vnote_yPos == MetaMapNotes_TempData_yPos) then
		MetaMapNotes_vnote_xPos = nil;
		MetaMapNotes_vnote_yPos = nil;
	end
	MetaMapNotes_MapUpdate();
end

function MetaMapNotes_MapUpdate()
	if(WorldMapButton:IsVisible() or MetaMapFrame:IsVisible()) then
		MetaMapNotes_WorldMapButton_OnUpdate();
	end
	if(Minimap:IsVisible()) then
		Minimap_OnUpdate(0);
	end
end

function MetaMapNotes_HideAll()
	MetaMapNotesEditFrame:Hide()
	MetaMapNotesSendFrame:Hide()
	MetaMapNotes_QuickNoteFrame:Hide()
	MetaMapNotes_ClearGUI()
end

function MetaMapNotes_FramesHidden()
	if(MetaMapNotesEditFrame:IsVisible() or MetaMapNotesSendFrame:IsVisible()
			or  MetaMapNotes_QuickNoteFrame:IsVisible()) then
		return false;
	else
		return true;
	end
end

function MetaMapNotes_DeleteNote(id, continent, zone)
	MetaMapNotes_HideAll()
	if id == 0 then
		MetaMapNotes_vnote_xPos = nil;
		MetaMapNotes_vnote_yPos = nil;
		MetaMapNotes_MapUpdate();
		return;
	elseif id == -1 then
		MetaMapNotes_PartyNoteData.xPos = nil;
		MetaMapNotes_PartyNoteData.yPos = nil;
		MetaMapNotes_PartyNoteData.continent = nil;
		MetaMapNotes_PartyNoteData.zone = nil;
		if(MetaMapNotes_MiniNote_Data.id == -1) then
			MetaMapNotes_MiniNote_Data = {};
		end
		MetaMapNotes_MapUpdate();
		return;
	end

	local currentZone
	local TempData = {};
	if(continent == nil or zone == nil) then
		continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	else
		currentZone = MetaMapNotes_Data[continent][zone];
	end
	TempData[continent] = {};
	TempData[continent][zone] = {};
	local lastEntry = MetaMapNotes_GetZoneTableSize(currentZone);

	if continent ~= -1 then
		MetaMapNotes_DeleteLines(continent, zone, currentZone[id].xPos, currentZone[id].yPos);
	end
	if(lastEntry ~= 0 and id <= lastEntry) then
		TempData[continent][zone] = MetaMapNotes_Data[continent][zone];
		MetaMapNotes_Data[continent][zone] = {};
		local newZone = TempData[continent][zone];
		for index, indexTable in newZone do
			if(index ~= id) then
				local oldData = newZone[index];
				MetaMapNotes_AddNewNote(continent, zone, oldData.xPos, oldData.yPos, oldData.name, oldData.inf1, oldData.inf2, oldData.creator, oldData.icon, oldData.ncol, oldData.in1c, oldData.in2c)
			end
		end
	end

	if continent == MetaMapNotes_MiniNote_Data.continent and zone == MetaMapNotes_MiniNote_Data.zone then
		if MetaMapNotes_MiniNote_Data.id > id then
			MetaMapNotes_MiniNote_Data.id = MetaMapNotes_MiniNote_Data.id - 1;
		elseif MetaMapNotes_MiniNote_Data.id == id then
			MetaMapNotes_ClearMiniNote(true);
		end
	end
	MetaMapNotes_MapUpdate();
end

function MetaMapNotes_GetZoneTableSize(zoneTable)
	local i = 0;
	for id in zoneTable do
		i = i + 1;
	end
	return i;
end

function MetaMapNotes_OnEnter(id)
	if MetaMapNotes_FramesHidden() then
		local x, y = this:GetCenter()
		local x2, y2 = WorldMapButton:GetCenter()
		local anchor = ""
		if x > x2 then
			anchor = "ANCHOR_LEFT"
		else
			anchor = "ANCHOR_RIGHT"
		end
		WorldMapTooltip:SetOwner(this, anchor)
		if id	== 0 then
			WorldMapTooltip:SetText(METAMAPNOTES_VNOTE_DEFAULTNAME)
		elseif id	== -1 then
			WorldMapTooltip:SetText(METAMAPNOTES_PARTYNOTE)
		else
			local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
			if(not currentZone) then return; end
			local blt = "";
			local cNr = currentZone[id].ncol
			if(currentZone[id].lootid ~= nil and currentZone[id].lootid ~= "") then
				blt = "|cffff00ffBLT";
			end
			WorldMapTooltip:AddDoubleLine(currentZone[id].name, blt, MetaMapNotes_Colors[cNr].r, MetaMapNotes_Colors[cNr].g, MetaMapNotes_Colors[cNr].b, MetaMapOptions.TooltipWrap)
			if currentZone[id].inf1 ~= nil and currentZone[id].inf1 ~= "" then
				cNr = currentZone[id].in1c
				WorldMapTooltip:AddLine(currentZone[id].inf1, MetaMapNotes_Colors[cNr].r, MetaMapNotes_Colors[cNr].g, MetaMapNotes_Colors[cNr].b, MetaMapOptions.TooltipWrap)
			end
			if currentZone[id].inf2 ~= nil and currentZone[id].inf2 ~= "" then
				cNr = currentZone[id].in2c
				WorldMapTooltip:AddLine(currentZone[id].inf2, MetaMapNotes_Colors[cNr].r, MetaMapNotes_Colors[cNr].g, MetaMapNotes_Colors[cNr].b, MetaMapOptions.TooltipWrap)
			end
			if(currentZone[id].creator ~= nil and currentZone[id].creator ~= "" and MetaMapOptions.MetaMapShowAuthor) then
				WorldMapTooltip:AddDoubleLine(METAMAPNOTES_CREATEDBY, currentZone[id].creator, 0.79, 0.69, 0.0, 0.79, 0.69, 0.0);
			end
		end
		WorldMapTooltip:Show()
	else
		WorldMapTooltip:Hide()
	end
end

function MetaMapNotes_MiniNote_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
	if(MetaMapNotes_MiniNote_Data.id == -1) then
		GameTooltip:SetText(METAMAPNOTES_PARTYNOTE);
	else
		GameTooltip:SetText(MetaMapNotes_MiniNote_Data.name,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.color].r,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.color].g,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.color].b);

		GameTooltip:AddLine(MetaMapNotes_MiniNote_Data.inf1,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in1c].r,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in1c].g,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in1c].b);

		GameTooltip:AddLine(MetaMapNotes_MiniNote_Data.inf2,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in2c].r,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in2c].g,
		MetaMapNotes_Colors[MetaMapNotes_MiniNote_Data.in2c].b);
		if(MetaMapNotes_MiniNote_Data.creator ~= nil and MetaMapNotes_MiniNote_Data.creator ~= "" and MetaMapOptions.MetaMapShowAuthor) then
			GameTooltip:AddDoubleLine(METAMAPNOTES_CREATEDBY, MetaMapNotes_MiniNote_Data.creator, 0.79, 0.69, 0.0, 0.79, 0.69, 0.0);
		end
	end
	GameTooltip:Show();
end

function MetaMapNotes_Note_OnClick(button, id)
	if(not MetaMapNotes_FramesHidden()) then return; end
	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	if(not currentZone) then return; end

	if MetaMapNotes_LastLineClick.GUIactive then
		id = id + 0
		local ax = currentZone[id].xPos
		local ay = currentZone[id].yPos
		if (MetaMapNotes_LastLineClick.x ~= ax or MetaMapNotes_LastLineClick.y ~= ay) and MetaMapNotes_LastLineClick.continent == continent and MetaMapNotes_LastLineClick.zone == zone then
			MetaMapNotes_ToggleLine(continent, zone, ax, ay, MetaMapNotes_LastLineClick.x, MetaMapNotes_LastLineClick.y)
		end
			MetaMapNotes_ClearGUI()
	elseif button == "LeftButton" and IsShiftKeyDown() then
		if (ChatFrameEditBox:IsVisible()) then
			local mode = 1;
			if(MetaMapFrame:IsVisible()) then mode = 2; end
			local tname = currentZone[id].name;
			local tinf1 = currentZone[id].inf1;
			local x = MetaMap_round(currentZone[id].xPos *100);
			local y = MetaMap_round(currentZone[id].yPos *100);
			local tzone = MetaMap_ZoneNames[continent][zone];
			if(strlen(tinf1) > 0) then tinf1 = " ["..tinf1.."] "; end
			local msg = tname.." "..tinf1.." ("..tzone.." - "..x..","..y..")";
			ChatFrameEditBox:Insert(msg);
		end
	elseif button == "LeftButton" and IsControlKeyDown() then
		if(not IsAddOnLoaded("MetaMapBLT")) then
			LoadAddOn("MetaMapBLT");
		end
		if(IsAddOnLoaded("MetaMapBLT")) then
			local LootID = MetaMapNotes_Data[continent][zone][id].lootid;
			local Name = MetaMapNotes_Data[continent][zone][id].name;
			MetaMapBLT_OnSelect(LootID, Name);
		else
			MetaMap_StatusPrint("MetaMapBLT addon is not enabled!", true);
		end
	elseif button == "LeftButton" then
		local width = WorldMapButton:GetWidth()
		local height = WorldMapButton:GetHeight()
		id = id + 0
		MetaMapNotes_TempData_Id = id
		local ax = currentZone[id].xPos
		local ay = currentZone[id].yPos
		if ax*1002 >= (1002 - 195) then
			xOffset = ax * width - 176
		else
			xOffset = ax * width
		end
		if ay*668 <= (668 - 156) then
			yOffset = -(ay * height) - 75
		else
			yOffset = -(ay * height) + 113
		end
		MetaMapNotesButtonSendNote:Enable()
		WorldMapTooltip:Hide()
		MetaMapNotes_OpenEditForExistingNote(MetaMapNotes_TempData_Id)
	elseif button == "RightButton" then
		MetaMapNotes_RBSelect();
	end
end

function MetaMapNotes_StartGUIToggleLine()
	MetaMapNotes_HideAll()
	WorldMapMagnifyingGlassButton:SetText(METAMAPNOTES_CLICK_ON_SECOND_NOTE)
	MetaMapNotes_LastLineClick.GUIactive = true
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();

	MetaMapNotes_LastLineClick.x = MetaMapNotes_Data[continent][zone][MetaMapNotes_TempData_Id].xPos
	MetaMapNotes_LastLineClick.y = MetaMapNotes_Data[continent][zone][MetaMapNotes_TempData_Id].yPos
	MetaMapNotes_LastLineClick.zone = zone
	MetaMapNotes_LastLineClick.continent = continent
end

function MetaMapNotes_StartMoveNote(ID)
	MetaMapNotes_HideAll()
	WorldMapMagnifyingGlassButton:SetText(METAMAPNOTES_CLICK_ON_LOCATION);
	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	MetaMapNotes_Relocate.continent = continent;
	MetaMapNotes_Relocate.zone = zone;
	MetaMapNotes_Relocate.id = ID;
end

function MetaMapNotes_MoveNote(continent, zone, id)
	local zoneTable = MetaMapNotes_Lines[continent][zone]
	local lineCount = MetaMapNotes_GetZoneTableSize(zoneTable)
	local currentX = MetaMapNotes_Data[continent][zone][id].xPos;
	local currentY = MetaMapNotes_Data[continent][zone][id].yPos;
	local centerX, centerY = WorldMapButton:GetCenter();
	local width = WorldMapButton:GetWidth();
	local height = WorldMapButton:GetHeight();
	local x, y = GetCursorPosition();
	x = x / WorldMapButton:GetEffectiveScale();
	y = y / WorldMapButton:GetEffectiveScale();
	local adjustedY = (centerY + height/2 - y) / height;
	local adjustedX = (x - (centerX - width/2)) / width;
	MetaMapNotes_Data[continent][zone][id].xPos = adjustedX;
	MetaMapNotes_Data[continent][zone][id].yPos = adjustedY;
	if(MetaMapNotes_MiniNote_Data.id == id) then
		MetaMapNotes_MiniNote_Data.xPos = adjustedX;
		MetaMapNotes_MiniNote_Data.yPos = adjustedY;
	end
	for i = 1, lineCount, 1 do
		if i <= lineCount then
			if(zoneTable[i].x1 == currentX and zoneTable[i].y1 == currentY) then
				zoneTable[i].x1 = adjustedX;
				zoneTable[i].y1 = adjustedY;
			elseif(zoneTable[i].x2 == currentX and zoneTable[i].y2 == currentY) then
				zoneTable[i].x2 = adjustedX;
				zoneTable[i].y2 = adjustedY;
			end
		end
	end
	WorldMapMagnifyingGlassButton:SetText(METAMAPNOTES_WORLDMAP_HELP_1.."\n"..METAMAPNOTES_WORLDMAP_HELP_2);
	MetaMapNotes_MapUpdate();
end

function MetaMapNotes_ClearGUI()
	WorldMapMagnifyingGlassButton:SetText(METAMAPNOTES_WORLDMAP_HELP_1.."\n"..METAMAPNOTES_WORLDMAP_HELP_2);
	MetaMapNotes_LastLineClick.GUIactive = false;
	MetaMapNotes_Relocate = {};
end

function MetaMapNotes_DrawLine(id, x1, y1, x2, y2)
	assert(x1 and y1 and x2 and y2)
	local MetaMapNotesLine = MetaMap_CreateLineObject(id);
	local positiveSlopeTexture = METAMAP_IMAGE_PATH.."LineTemplatePositive256"
	local negativeSlopeTexture = METAMAP_IMAGE_PATH.."LineTemplateNegative256"
	local width = WorldMapDetailFrame:GetWidth()
	local height = WorldMapDetailFrame:GetHeight()
	local deltax = math.abs((x1 - x2) * width)
	local deltay = math.abs((y1 - y2) * height)
	local xOffset = math.min(x1,x2) * width
	local yOffset = -(math.min(y1,y2) * height)
	local lowerpixel = math.min(deltax, deltay)
	lowerpixel = lowerpixel / 256
	if lowerpixel > 1 then
		lowerpixel = 1
	end
	if deltax == 0 then
		deltax = 2
		MetaMapNotesLine:SetTexture(0, 0, 0)
		MetaMapNotesLine:SetTexCoord(0, 1, 0, 1)
	elseif deltay == 0 then
		deltay = 2
		MetaMapNotesLine:SetTexture(0, 0, 0)
		MetaMapNotesLine:SetTexCoord(0, 1, 0, 1)
	elseif x1 - x2 < 0 then
		if y1 - y2 < 0 then
			MetaMapNotesLine:SetTexture(negativeSlopeTexture)
			MetaMapNotesLine:SetTexCoord(0, lowerpixel, 0, lowerpixel)
		else
			MetaMapNotesLine:SetTexture(positiveSlopeTexture)
			MetaMapNotesLine:SetTexCoord(0, lowerpixel, 1-lowerpixel, 1)
		end
	else
		if y1 - y2 < 0 then
			MetaMapNotesLine:SetTexture(positiveSlopeTexture)
			MetaMapNotesLine:SetTexCoord(0, lowerpixel, 1-lowerpixel, 1)
		else
			MetaMapNotesLine:SetTexture(negativeSlopeTexture)
			MetaMapNotesLine:SetTexCoord(0, lowerpixel, 0, lowerpixel)
		end
	end

	if(MetaMapFrame:IsVisible()) then
		MetaMapNotesLine:SetPoint("TOPLEFT", "MetaMapFrame", "TOPLEFT", xOffset, yOffset)
	else
		MetaMapNotesLine:SetPoint("TOPLEFT", "WorldMapDetailFrame", "TOPLEFT", xOffset, yOffset)
	end
	MetaMapNotesLine:SetWidth(deltax)
	MetaMapNotesLine:SetHeight(deltay)
	MetaMapNotesLine:Show()
end

function MetaMapNotes_DeleteLines(continent, zone, x, y)
	local zoneTable = MetaMapNotes_Lines[continent][zone]
	local lineCount = MetaMapNotes_GetZoneTableSize(zoneTable)
	local offset = 0

	for i = 1, lineCount, 1 do
		if (zoneTable[i-offset].x1 == x and zoneTable[i-offset].y1 == y) or (zoneTable[i-offset].x2 == x and zoneTable[i-offset].y2 == y) then
			for j = i, lineCount-1, 1 do
				zoneTable[j-offset].x1 = zoneTable[j+1-offset].x1
				zoneTable[j-offset].x2 = zoneTable[j+1-offset].x2
				zoneTable[j-offset].y1 = zoneTable[j+1-offset].y1
				zoneTable[j-offset].y2 = zoneTable[j+1-offset].y2
			end
			zoneTable[lineCount-offset] = nil
			offset = offset + 1
		end
	end
	MetaMapNotes_LastLineClick.zone = 0
end

function MetaMapNotes_ToggleLine(continent, zone, x1, y1, x2, y2)
	local zoneTable = MetaMapNotes_Lines[continent][zone]
	local newline = true
	local lineCount = MetaMapNotes_GetZoneTableSize(zoneTable)

	for i = 1, lineCount, 1 do
		if i <= lineCount then
			if (zoneTable[i].x1 == x1 and zoneTable[i].y1 == y1 and
					zoneTable[i].x2 == x2 and zoneTable[i].y2 == y2) or
					(zoneTable[i].x1 == x2 and zoneTable[i].y1 == y2 and
					zoneTable[i].x2 == x1 and zoneTable[i].y2 == y1) then
				for j = i, lineCount-1, 1 do
					zoneTable[j].x1 = zoneTable[j+1].x1
					zoneTable[j].x2 = zoneTable[j+1].x2
					zoneTable[j].y1 = zoneTable[j+1].y1
					zoneTable[j].y2 = zoneTable[j+1].y2
				end
				zoneTable[lineCount] = nil
				PlaySound("igMainMenuOption")
				newline = false
				lineCount = lineCount - 1
			end
		end
	end
	if(newline) then
		zoneTable[lineCount+1] = {}
		zoneTable[lineCount+1].x1 = x1
		zoneTable[lineCount+1].x2 = x2
		zoneTable[lineCount+1].y1 = y1
		zoneTable[lineCount+1].y2 = y2
	end
	MetaMapNotes_LastLineClick.zone = 0
	MetaMapNotes_MapUpdate()
end

function MetaMapNotes_NewNoteSlot()
	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	if(not currentZone) then return 1; end
	return MetaMapNotes_GetZoneTableSize(currentZone) + 1
end

function MetaMapNotes_SetPartyNote(xPos, yPos)
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	xPos = floor(xPos * 1000000) / 1000000
	yPos = floor(yPos * 1000000) / 1000000
	MetaMapNotes_PartyNoteData.continent = continent
	MetaMapNotes_PartyNoteData.zone = zone
	MetaMapNotes_PartyNoteData.xPos = xPos
	MetaMapNotes_PartyNoteData.yPos = yPos
	if MetaMapNotes_MiniNote_Data.icon == "party" or MetaMapNotes_Options[16] ~= "off" then
		MetaMapNotes_MiniNote_Data.zonetext = mapName;
		MetaMapNotes_MiniNote_Data.id = -1;
		MetaMapNotes_MiniNote_Data.continent = continent;
		MetaMapNotes_MiniNote_Data.zone = zone;
		MetaMapNotes_MiniNote_Data.xPos = xPos;
		MetaMapNotes_MiniNote_Data.yPos = yPos;
		MetaMapNotes_MiniNote_Data.name = METAMAPNOTES_PARTYNOTE;
		MetaMapNotes_MiniNote_Data.color = 0;
		MetaMapNotes_MiniNote_Data.icon = "party"
		MiniNotePOITexture:SetTexture(METAMAP_ICON_PATH.."Icon"..MetaMapNotes_MiniNote_Data.icon)
		MiniNotePOI:Show()
	end
	MetaMapNotes_MapUpdate()
end

function MetaMapNotes_WorldMapButton_OnClick(...)
	if(not MetaMapNotes_FramesHidden()) then return; end
	local mouseButton, button = unpack(arg)
	local continent, zone = MetaMap_GetCurrentMapInfo();

	if(MetaMapNotes_Relocate.id ~= nil and zone > 0) then
		if(mouseButton == "LeftButton" and not IsControlKeyDown() and not IsShiftKeyDown()) then
			MetaMapNotes_MoveNote(MetaMapNotes_Relocate.continent, MetaMapNotes_Relocate.zone, MetaMapNotes_Relocate.id)
			MetaMapNotes_Relocate = {};
			return;
		end
	end

	if(MetaMapFrame:IsVisible() and mouseButton == "RightButton") then
		MetaMap_Toggle(false);
		MetaMapNotes_MapUpdate();
		return;
	elseif mouseButton == "RightButton" or (mouseButton == "LeftButton" and not IsControlKeyDown() and not IsShiftKeyDown()) then
		if(MetaMapFrame:IsVisible() and mouseButton == "LeftButton") then
			return;
		end
		orig_MetaMapNotes_WorldMapButton_OnClick(unpack(arg));
		return;
	else
		if(MetaMapOptions.UseMapMod and not MetaMapFrame:IsVisible() and IsControlKeyDown()) then
			orig_MetaMapNotes_WorldMapButton_OnClick(unpack(arg));
			return;
		end
	end

	if(continent == -1 or zone ~= 0 or MetaMapFrame:IsVisible()) then
		if not button then
			button = this
		end
		local centerX, centerY = button:GetCenter()
		local width = button:GetWidth()
		local height = button:GetHeight()
		local x, y = GetCursorPosition()
		x = x / button:GetEffectiveScale()
		y = y / button:GetEffectiveScale()
		local adjustedY = (centerY + height/2 - y) / height
		local adjustedX = (x - (centerX - width/2)) / width

		if(IsShiftKeyDown()) then
			MetaMapNotes_SetPartyNote(adjustedX, adjustedY);
		elseif(IsControlKeyDown()) then
			MetaMapNotes_ShowNewFrame(adjustedX, adjustedY);
		end
	end
end

function MetaMapNotes_WorldMapButton_OnUpdate(...)
	if(MetaMapNotes_Drawing) then
		return;
	end
	local lastNote = 0;
	local lastLine = 0;
	local width = WorldMapButton:GetWidth();
	local height = WorldMapButton:GetHeight();
	local xOffset,yOffset = 0;
	local currentLineZone;
	local continent, zone, currentZone = MetaMap_GetCurrentMapInfo();
	MetaMapNotes_Drawing = true;

	if(currentZone and MetaMapOptions.MetaMapShowNotes) then
		if(continent ==-1) then
			currentLineZone = MetaMapNotes_Lines[GetRealZoneText];
		else
			currentLineZone = MetaMapNotes_Lines[continent][zone];
		end
		for i, value in currentZone do
			local temp = MetaMap_CreateNoteObject(i);
			local xOffset = currentZone[i].xPos * width
			local yOffset = -currentZone[i].yPos * height
			if(MetaMapFrame:IsVisible()) then
				temp:SetParent("MetaMapFrame");
				temp:SetPoint("CENTER", "MetaMapFrame", "TOPLEFT", xOffset, yOffset)
			else
				temp:SetParent("WorldMapButton");
				temp:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", xOffset, yOffset)
			end
			getglobal("MetaMapNotesPOI"..i.."Texture"):SetTexture(METAMAP_ICON_PATH.."Icon"..currentZone[i].icon)
			if MetaMapNotes_Options[currentZone[i].icon] ~= "off" then
				if (MetaMapNotes_Options[10] ~= "off" and currentZone[i].creator == UnitName("player")) or (MetaMapNotes_Options[11] ~= "off" and currentZone[i].creator ~= UnitName("player")) then
					temp:Show()
				end
			else
				temp:Hide()
			end
			lastNote = i;
			MetaMapNotes_ZoneNotes = i;
		end
		if MetaMapNotes_Options[12] ~= "off" and lastNote ~= 0 then
			if getglobal("MetaMapNotesPOI"..lastNote):IsVisible() then
				getglobal("MetaMapNotesPOI"..lastNote.."Texture"):SetTexture(METAMAP_ICON_PATH.."Icon"..currentZone[lastNote].icon.."red")
			end
		end
		if MetaMapNotes_Options[13] ~= "off" and MetaMapNotes_MiniNote_Data.continent == continent and
			MetaMapNotes_MiniNote_Data.zone == zone and MetaMapNotes_MiniNote_Data.id > 0 then
			getglobal("MetaMapNotesPOI"..MetaMapNotes_MiniNote_Data.id.."Texture"):
			SetTexture(METAMAP_ICON_PATH.."Icon"..MetaMapNotes_MiniNote_Data.icon.."blue")
		end
		for i=lastNote+1, MetaMapNotes_LastNote, 1 do
			getglobal("MetaMapNotesPOI"..i):Hide()
		end
		if(currentLineZone) then
			for i,line in currentLineZone do
				MetaMapNotes_DrawLine(i, line.x1, line.y1, line.x2, line.y2)
				lastLine = i;
			end
		end
		for i=lastLine+1, MetaMapNotes_LastLine, 1 do
			getglobal("MetaMapNotesLines_"..i):Hide()
		end
	else
		for i=1, MetaMapNotes_LastNote, 1 do
			getglobal("MetaMapNotesPOI"..i):Hide();
		end

		for i=1, MetaMapNotes_LastLine, 1 do
			getglobal("MetaMapNotesLines_"..i):Hide();
		end
	end

	if currentZone then
		-- vNote button
		if MetaMapNotes_vnote_xPos ~= nil and zone ~= 0 then
			xOffset = MetaMapNotes_vnote_xPos * width
			yOffset = -MetaMapNotes_vnote_yPos * height
			if(MetaMapFrame:IsVisible()) then
				MetaMapNotesPOIvNote:SetPoint("CENTER", "MetaMapFrame", "TOPLEFT", xOffset, yOffset)
			else
				MetaMapNotesPOIvNote:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", xOffset, yOffset)
			end
			MetaMapNotesPOIvNote:Show()
		else
			MetaMapNotesPOIvNote:Hide()
		end

	-- party note
		if MetaMapNotes_PartyNoteData.xPos ~= nil and zone == MetaMapNotes_PartyNoteData.zone and
				continent == MetaMapNotes_PartyNoteData.continent then
			if MetaMapNotes_Options[13] ~= "off" and MetaMapNotes_MiniNote_Data.icon == "party" then
				MetaMapNotesPOIpartyTexture:SetTexture(METAMAP_ICON_PATH.."Iconpartyblue")
			else
				MetaMapNotesPOIpartyTexture:SetTexture(METAMAP_ICON_PATH.."Iconparty")
			end
			xOffset = MetaMapNotes_PartyNoteData.xPos * width
			yOffset = -MetaMapNotes_PartyNoteData.yPos * height
			if(MetaMapFrame:IsVisible()) then
				MetaMapNotesPOIparty:SetParent("MetaMapFrame");
				MetaMapNotesPOIparty:SetPoint("CENTER", "MetaMapFrame", "TOPLEFT", xOffset, yOffset)
			else
				MetaMapNotesPOIparty:SetParent("WorldMapButton");
				MetaMapNotesPOIparty:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", xOffset, yOffset)
			end
			MetaMapNotesPOIparty:Show()
		else
			MetaMapNotesPOIparty:Hide()
		end
	end
	MetaMapNotes_Drawing = nil
	MetaMapText_NoteTotals:SetText(METAMAP_NOTES_SHOWN..": ".."|cffffffff"..(lastNote).."  ".."|cfff0B300"..METAMAP_LINES_SHOWN..": ".."|cffffffff"..(lastLine));

	if(MetaMapOptions.UseMapMod and IsAddOnLoaded("CT_MapMod")) then
		if(MetaMapFrame:IsVisible()) then
			CT_NumNotes:Hide();
			MetaMapText_NoteTotals:Show();
		else
			CT_NumNotes:Show();
			MetaMapText_NoteTotals:Hide();
		end
	else
		if(IsAddOnLoaded("CT_MapMod")) then
			CT_NumNotes:Hide();
		end
		MetaMapText_NoteTotals:Show();
	end
	MetaMapList_Init();
end

function MetaMap_DeleteNotesListInit()
	local Temp_List = {};
	for continent, continentTable in MetaMapNotes_Data do
		for zone, zoneTable in continentTable do
			for index, indexTable in zoneTable do
				local currentZone = MetaMapNotes_Data[continent][zone][index];
				if(Temp_List[currentZone.creator] == nil) then
					Temp_List[currentZone.creator] = currentZone.creator;
				end
			end
		end
	end
	for index, creators in Temp_List do
		local uText;
		if(Temp_List[index] == "") then
			uText = "Unsigned";
		else
			uText = Temp_List[index];
		end
		local info = {
		checked = nil;
		notCheckable = 1;
		text = uText;
		func = MetaMap_DeleteNotesList_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_JustifyText("LEFT", MetaMap_DeleteNotesList)
	UIDropDownMenu_SetText("[Click for Creator]", MetaMap_DeleteNotesList)
end

function MetaMap_DeleteNotesList_OnClick()
	local creator = this:GetText();
	if(creator == "Unsigned") then
		cFlag = "";
	else
		cFlag = creator;
	end	
	UIDropDownMenu_SetSelectedName(MetaMap_DeleteNotesList, this:GetText());
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	StaticPopupDialogs["Delete_Notes"] = {
		text = TEXT(format(METAMAPNOTES_BATCHDELETE, mapName, creator)),
		button1 = TEXT(ACCEPT),
		button2 = TEXT(DECLINE),
		OnAccept = function()
			MetaMap_DeleteNotes(cFlag, nil, mapName);
		end,
		timeout = 60,
		showAlert = 1,
	};
	StaticPopup_Show("Delete_Notes");
end

function MetaMap_DeleteNotes(creator, name, zoneName)
	if(zoneName == nil or zoneName == "World") then
		assert(creator ~= nil, "ERROR: nil creator passed to DeleteNotesByCreatorAndName!");
		for continent, continentTable in MetaMapNotes_Data do
			for zone, zoneTable in continentTable do
				for id=MetaMapNotes_GetZoneTableSize(zoneTable), 1, -1 do
					if(zoneTable[id] ~= nil and creator == zoneTable[id].creator and (name == zoneTable[id].name or name == nil)) then
						MetaMapNotes_DeleteNote(id, continent, zone)
					end
				end
			end
		end
	else
		local continent, setZone = MetaMap_NameToZoneID(zoneName, 1);
		if(zoneName == "Kalimdor") then
			continent = 1;
		elseif(zoneName == "Eastern Kingdoms") then
			continent = 2;
		end
		for zone, zoneTable in MetaMapNotes_Data[continent] do
			for id=MetaMapNotes_GetZoneTableSize(zoneTable), 1, -1 do
				if(setZone == 0 and zoneTable[id] ~= nil and creator == zoneTable[id].creator) then
					MetaMapNotes_DeleteNote(id, continent, zone);
				elseif(setZone == zone and zoneTable[id] ~= nil and creator == zoneTable[id].creator) then
					MetaMapNotes_DeleteNote(id, continent, zone);
				end
			end
		end
	end
	if(creator == "") then creator = "Unsigned"; end
	if(zoneName ~= nil) then
		MetaMap_StatusPrint(format(METAMAPNOTES_DELETED_BY_ZONE, zoneName, creator), true);
	elseif(name ~= nil) then
		MetaMap_StatusPrint(format(METAMAPNOTES_DELETED_BY_NAME, creator, name), true);
	else
		MetaMap_StatusPrint(format(METAMAPNOTES_DELETED_BY_CREATOR, creator), true);
	end
end

function MetaMapPOI_OnEvent(mode)
	if(GetCurrentMapZone() == 0 or GetCurrentMapContinent() == -1) then return; end
	local noteAdded1, noteAdded2;
	local name, unknown, textureIndex, x, y;
	for landmarkIndex = 1, GetNumMapLandmarks(), 1 do
		name, unknown, textureIndex, x, y = GetMapLandmarkInfo(landmarkIndex);
		if(mode == 1) then
			if(textureIndex==6) then
				noteAdded1 = MetaMapPOI_AddNote(name, textureIndex, x, y);
			end
		else
			noteAdded2 = MetaMapPOI_AddNote(name, textureIndex, x, y);
		end
	end
	if(noteAdded1 and noteAdded2) then
		MetaMap_StatusPrint("MetaMapPOI updated map notes for "..GetRealZoneText(), true);
	end
	if(noteAdded2) then
		MetaMap_StatusPrint("MetaMapPOI updated map notes for "..GetRealZoneText(), true);
	end
	if(noteAdded1) then
		MetaMap_StatusPrint("MetaMapPOI set Guard note for "..name, true);
	end
end

function MetaMapPOI_AddNote(name, textureIndex, x, y)
	if (x == 0 and y == 0) then return false; end
	local continent, zone, currentZone, mapName = MetaMap_GetCurrentMapInfo();
	local icon = 9;

	if (textureIndex == 15) then
		icon = 5;
	elseif (textureIndex == 6) then
		icon = 6;
	end
	local added = MetaMapNotes_AddNewNote(continent, zone, x, y, name, "", "", METAMAPPOI_NAME, icon, 6, 0, 0);
	return added, icon;
end

function MetaMapPOI_RemovePOI()
	if(MetaMapZonePOI) then
		if( GetCurrentMapZone() == 0) then return; end
		local name, unknown, textureIndex, x, y;
		NumMapLandmarks = GetNumMapLandmarks();
		for landmarkIndex = 1, NumMapLandmarks, 1 do
			name, unknown, textureIndex, x, y = GetMapLandmarkInfo(landmarkIndex);
			MetaMapNotes_DeleteNotesByCreatorAndName(METAMAPPOI_NAME, name);
		end
	else
		MetaMapNotes_DeleteNotesByCreatorAndName(METAMAPPOI_NAME);
	end
end

function MetaKB_StripTextColors(textString)
	-- this function is designed to replace
	-- |cff00AA00Colored Text|r with Colored Text
	if(textString ~= nil and textString ~= "") then
		return string.gsub(textString, "|c[%dA-Fa-f][%dA-Fa-f][%dA-Fa-f][%dA-Fa-f][%dA-Fa-f]"..
				"[%dA-Fa-f][%dA-Fa-f][%dA-Fa-f](.*)|r", "%1");
	else
		assert(false, "nil or invalid parameter to StripTextColors");
	end
end

function MetaKB_ToggleSetRange(range)
	for i=1, 5 do
		if(i == range) then
			local checkButton = getglobal("MetaKB_RangeCheck"..i);
			checkButton:SetChecked(true);
		else
			local checkButton = getglobal("MetaKB_RangeCheck"..i);
			checkButton:SetChecked(false);
		end
	end
	MetaMapOptions.RangeCheck = range;
end

function MetaKB_UpdateKeySelectedUnit()
	if (not UnitExists("target")) then
		MetaMap_StatusPrint(METAKB_NOTARGET,MetaMapOptions.ShowUpdates);
		return;
	else
		if(IsControlKeyDown()) then
			MetaKB_overRide = true;
		end
		MetaKB_AddUnitInfo("target");
			MetaKB_overRide = false;
	end
end

function MetaKB_AddUnitInfo(UnitSelect)
	if( not CheckInteractDistance(UnitSelect, MetaMapOptions.RangeCheck) and MetaMapOptions.RangeCheck ~= 5) then
		return;
	end
	local continent, zone = MetaMap_NameToZoneID(GetRealZoneText());
	if(type(continent) == "string") then
		MetaMap_StatusPrint(METAMAPNOTES_INVALIDZONE, MetaMapOptions.ShowUpdates);
		return;
	end
	local icon = 3; --green by default
	local unitName = UnitName(UnitSelect);
	local ncol = 0;
	local desc1 = "";
	local desc2 = "";
	local playerX, playerY = GetPlayerMapPosition("player")

	playerX = MetaMap_round(playerX*10000)
	playerY = MetaMap_round(playerY*10000)
	unitName = MetaKB_StripTextColors(unitName);

	if(UnitReaction("player", UnitSelect) < 4) then
		if(UnitClassification(UnitSelect) ~= "normal") then
			desc1 = UnitClassification(UnitSelect).." ";
		end
		if(UnitCreatureType(UnitSelect) ~= nil) then
			desc1 = desc1..UnitCreatureType(UnitSelect).." "
		end
		if(UnitClass(UnitSelect) ~= nil) then
			desc1 = desc1..UnitClass(UnitSelect);
		end
		if(UnitLevel(UnitSelect) == "-1") then
			desc2 = "Level ??";
		else
			desc2 = "Level "..UnitLevel(UnitSelect);
		end
		icon = 1;
	elseif(UnitReaction("player", UnitSelect) == 4) then
		if(GameTooltipTextLeft2:GetText() ~= nil) then
			desc1 = string.sub(GameTooltipTextLeft2:GetText(), 9);
		end
		desc2 = "Level "..UnitLevel(UnitSelect);
		icon = 0;
	elseif(UnitReaction("player", UnitSelect) > 4 and UnitIsPlayer(UnitSelect)) then
		unitName = UnitPVPName(UnitSelect);
		desc1 = UnitRace(UnitSelect).." "..UnitClass(UnitSelect);
		desc2 = "Level "..UnitLevel(UnitSelect);
		icon = 7;
	elseif(UnitReaction("player", UnitSelect) < 4 and UnitIsPlayer(UnitSelect)) then
		unitName = UnitPVPName(UnitSelect);
		desc1 = UnitRace(UnitSelect).." "..UnitClass(UnitSelect);
		desc2 = "Level "..UnitLevel(UnitSelect);
		icon = 6;
	else
		local check = GameTooltipTextLeft2:GetText();
		if (check ~= nil) then
			if(string.find(check,"Level")) then
				if(GameTooltipTextLeft3 ~= "" and GameTooltipTextLeft3 ~= nil) then
					desc1 = GameTooltipTextLeft3:GetText();
					desc2 = GameTooltipTextLeft2:GetText();
				end
			else
				if(GameTooltipTextLeft2 ~= "" and GameTooltipTextLeft2 ~= nil) then
					desc1 = GameTooltipTextLeft2:GetText();
				end
				if(GameTooltipTextLeft3 ~= "" and GameTooltipTextLeft3 ~= nil) then
					desc2 = GameTooltipTextLeft3:GetText();
				end
			end
		end
		icon = 3;
	end
	if(desc1 == nil) then desc1 = ""; end
	if(desc2 == nil) then desc2 = ""; end

	local changedSomething = false;
	local addedSomething = false;
	local updatedSomething = false;
	local currentUnit;

	if(MetaKB_Data[MetaKB_dbID][unitName] == nil) then
		MetaKB_Data[MetaKB_dbID][unitName] = {};
		MetaMap_StatusPrint(format(TEXT(METAKB_DISCOVERED_UNIT), unitName), MetaMapOptions.ShowUpdates);
	end
	currentUnit = MetaKB_Data[MetaKB_dbID][unitName];
	if(currentUnit[continent] == nil) then
		currentUnit[continent] = {};
	end
	if(currentUnit[continent][zone] == nil) then
		currentUnit[continent][zone] = {};
		currentUnit[continent][zone]["inf1"] = desc1;
		currentUnit[continent][zone]["inf2"] = desc2;
		currentUnit[continent][zone]["icon"] = icon;
		currentUnit[continent][zone][1] = 20000;
		currentUnit[continent][zone][2] = -1;
		currentUnit[continent][zone][3] = -1;
		currentUnit[continent][zone][4] = 20000;
		addedSomething = true
	else
		currentUnit[continent][zone]["icon"] = icon;
		if(currentUnit[continent][zone]["inf1"] == "") then
			currentUnit[continent][zone]["inf1"] = desc1;
			updatedSomething = true;
		end
		if(currentUnit[continent][zone]["inf2"] == "") then
			currentUnit[continent][zone]["inf2"] = desc2;
			updatedSomething = true;
		end
	end		

	local coords = currentUnit[continent][zone];

	if(playerX < coords[4]) then
		currentUnit[continent][zone][4] = playerX;
		changedSomething = true;
	end
	if(playerY < coords[1]) then
		currentUnit[continent][zone][1] = playerY;
		changedSomething = true;
	end
	if(playerX > coords[2]) then
		currentUnit[continent][zone][2] = playerX;
		changedSomething = true;
	end
	if(playerY > coords[3]) then
		currentUnit[continent][zone][3] = playerY;
		changedSomething = true;
	end

	if(MetaMapOptions.NewTargetNote or MetaKB_overRide) then
		MetaKB_AddMapNotes(unitName, GetRealZoneText(), 0);
	end
	if(MetaMapOptions.KBstate) then
		if(addedSomething) then
			MetaMap_StatusPrint(format(TEXT(METAKB_ADDED_UNIT_IN_ZONE), unitName, GetRealZoneText()), MetaMapOptions.ShowUpdates);
		end
		if(changedSomething and not addedSomething) then
			MetaMap_StatusPrint(format(TEXT(METAKB_UPDATED_MINMAX_XY), unitName, GetRealZoneText()), MetaMapOptions.ShowUpdates);
		end
		if(updatedSomething) then
			MetaMap_StatusPrint(format(TEXT(METAKB_UPDATED_INFO), unitName, GetRealZoneText()), MetaMapOptions.ShowUpdates);
		end
	else
		currentUnit = nil;
	end
end

function MetaKB_UpdateScrollFrame()
	for iScrollFrameButton = 1, METAKB_SCROLL_FRAME_BUTTONS_SHOWN, 1 do
		local buttonIndex = iScrollFrameButton + FauxScrollFrame_GetOffset(MetaKB_ScrollFrame);
		local scrollFrameButton = getglobal("MetaKB_ScrollFrameButton"..iScrollFrameButton);
		local NameButton = getglobal("MetaKB_ScrollFrameButton"..iScrollFrameButton.."Name");
		local Info1Button = getglobal("MetaKB_ScrollFrameButton"..iScrollFrameButton.."Info1");
		local Info2Button = getglobal("MetaKB_ScrollFrameButton"..iScrollFrameButton.."Info2");
		local CoordsButton = getglobal("MetaKB_ScrollFrameButton"..iScrollFrameButton.."Coords");

		if(buttonIndex < g_SearchResults.onePastEnd) then
			if(g_SearchResults[buttonIndex]["zoneName"] == GetRealZoneText()) then
				-- Unit is in the same zone, show in yellow
				NameButton:SetText(g_SearchResults[buttonIndex]["name"]);
				Info1Button:SetText(g_SearchResults[buttonIndex]["desc"]);
				Info2Button:SetText(g_SearchResults[buttonIndex]["level"]);
				CoordsButton:SetText(g_SearchResults[buttonIndex]["location"]);
				if(g_SearchResults[buttonIndex]["cCode"] == 2) then
					CoordsButton:SetTextColor(0,1,0)
				else
					-- Unit is within range, show in green
					CoordsButton:SetTextColor(1,1,0)
				end
				scrollFrameButton:Show();
			else
				if(MetaKB_ShowAllZones or MetaMapOptions.EmbedKB) then
					-- Unit is in a different zone, show in red
					NameButton:SetText(g_SearchResults[buttonIndex]["name"]);
					Info1Button:SetText(g_SearchResults[buttonIndex]["desc"]);
					Info2Button:SetText(g_SearchResults[buttonIndex]["level"]);
					CoordsButton:SetText(g_SearchResults[buttonIndex]["zoneName"]);
					CoordsButton:SetTextColor(1,0,0)
					scrollFrameButton:Show();
				else
					scrollFrameButton:Hide();
				end
			end
			local ncol = g_SearchResults[buttonIndex]["ncol"];
			NameButton:SetTextColor(MetaMapNotes_Colors[ncol].r,MetaMapNotes_Colors[ncol].g,MetaMapNotes_Colors[ncol].b)
			Info1Button:SetTextColor(0.8,0.8,0.8)
			Info2Button:SetTextColor(0.5,0.5,0.8)
		else
			scrollFrameButton:Hide();
		end
	end
	FauxScrollFrame_Update(MetaKB_ScrollFrame, g_SearchResults.onePastEnd - 1,
        METAKB_SCROLL_FRAME_BUTTONS_SHOWN, METAKB_SCROLL_FRAME_BUTTON_HEIGHT)
end

function MetaKB_BuildSearchResults()
	local cCode = 1;
	local nameCount = 0;
	local zoneCount = 0;
	local tempZones = {};
	local currentContinent, currentZone;
	local currentContinent, currentZone = MetaMap_GetCurrentMapInfo();
	if(currentZone == nil) then return; end
	g_SearchResults = {};

	for name, continentTable in MetaKB_Data[MetaKB_dbID] do
		for continent, zoneTable in continentTable do
			for zone in zoneTable do
				if(continent == currentContinent and zone == currentZone or MetaKB_ShowAllZones) then
					if(MetaMap_ZoneNames[continent] == nil or MetaMap_ZoneNames[continent][zone] == nil) then
						break; -- skip incorrect data entry
					end
					local zoneName = MetaMap_ZoneNames[continent][zone];
					local inf1 = MetaKB_Data[MetaKB_dbID][name][continent][zone]["inf1"];
					local inf2 = MetaKB_Data[MetaKB_dbID][name][continent][zone]["inf2"];
					local ncol = MetaKB_Data[MetaKB_dbID][name][continent][zone]["icon"];
					local coords = MetaKB_Data[MetaKB_dbID][name][continent][zone];
					local cleanCoords = {};
					local coordString = "";
					if(ncol == 1) then ncol = 2;
					elseif(ncol == 2) then ncol = 6;
					elseif(ncol == 3) then ncol = 4;
					elseif(ncol == 6) then ncol = 1; end
					if(zoneName ~= GetRealZoneText() or continent == 0 or type(continent) == "string") then
						coordString = zoneName;
					else
						for i=1,4 do
							cleanCoords[i] = MetaMap_round(coords[i]/100, 0);
						end
						local dx = coords[2]/100 - coords[4]/100;
						local dy = coords[3]/100 - coords[1]/100;
						local centerx = coords[4]/100 + dx/2;
						local centery = coords[1]/100 + dy/2;
						-- truncate to two digits after the decimal again
						centerx = MetaMap_round(centerx, 0);
						centery = MetaMap_round(centery, 0);
						-- if the NPC has a range of 3 map units or greater, show ranges
						if dx >= 3 or dy >= 3 then
							coordString = " ("..cleanCoords[4].."-"..cleanCoords[2].."),"..
 	                              " ("..cleanCoords[1].."-"..cleanCoords[3]..")"
						else
							-- otherwise just show an averaged point
							coordString = " ("..centerx..", "..centery..")"
						end
						if(centerx > (g_PlayerX +3) or centerx < (g_PlayerX -3) and centery > (g_PlayerY +3) or centery < (g_PlayerY -3)) then
							cCode = 1;
						else
			 				cCode = 2;
						end
					end
					if(string.find(string.lower(name),string.lower(g_LastSearch),1,true)~=nil
						or string.find(string.lower(inf1),string.lower(g_LastSearch),1,true)~=nil
						or string.find(string.lower(inf2),string.lower(g_LastSearch),1,true)~=nil
						or string.find(string.lower(coordString),string.lower(g_LastSearch),1,true)~=nil) then
						tinsert(g_SearchResults, {name = name, zoneName = zoneName, desc = inf1, level = inf2, ncol = ncol, location = coordString, cCode = cCode});
						nameCount = nameCount + 1;
						if tempZones[zoneName] == nil then
							zoneCount = zoneCount + 1;
							tempZones[zoneName] = 0;
						end
					end
				end
			end
		end
	end
	MetaKB_ResultFontString:SetText("Found "..nameCount.." NPC/MoBs in "..zoneCount.." zones");
	g_SearchResults.onePastEnd = nameCount +1;
	MetaKBList_SortBy(MetaMap_sortType, MetaMap_sortDone)
end

function MetaKBList_SortBy(aSortType, aSortDone)
	MetaMap_sortType = aSortType;
	MetaMap_sortDone = aSortDone;
  table.sort(g_SearchResults, MetaSort_Criteria);
	if(not MetaMap_sortDone)then
		local count = g_SearchResults.onePastEnd;
		g_SearchResults = MetaKB_InvertList(g_SearchResults);
		g_SearchResults.onePastEnd = count;
	end
	MetaKB_UpdateScrollFrame();
end

function MetaSort_Criteria(a, b)
	if(MetaMap_sortType == METAKB_SORTBY_NAME) then
		if (a.name < b.name) then
			return true;
		elseif (a.name > b.name) then
			return false;
		end
	elseif(MetaMap_sortType == METAKB_SORTBY_DESC) then
		if (a.desc < b.desc) then
			return true;
		elseif (a.desc > b.desc) then
			return false;
		end
	elseif(MetaMap_sortType == METAKB_SORTBY_LEVEL) then
		if (a.level < b.level) then
			return true;
		elseif (a.level > b.level) then
			return false;
		end
	elseif(MetaMap_sortType == METAKB_SORTBY_LOCATION) then
		if (a.location < b.location) then
			return true;
		elseif (a.location > b.location) then
			return false;
		end
	else
		if (a == nil) then
			if (b == nil) then
				return false;
			else
				return true;
			end
		elseif (b == nil) then
			return false;
		end
	end
end

function MetaKB_InvertList(list)
  local newlist = {};
  local count = table.getn(list);
  for i=1,count
  do
    table.insert(newlist, list[(count +1) -i]);
  end
  return newlist;
end

function MetaKB_Search(searchText, suppressErrors)
	if(searchText == nil) then searchText = g_LastSearch; end
	if(suppressErrors == nil) then suppressErrors = false; end

	g_LastSearch = searchText;
	if(not MetaMapOptions.EmbedKB) then
		SetMapToCurrentZone();
	end
	g_PlayerX, g_PlayerY = GetPlayerMapPosition("player");
	g_PlayerX = MetaMap_round(g_PlayerX * 100);
	g_PlayerY = MetaMap_round(g_PlayerY * 100);
	FauxScrollFrame_SetOffset(MetaKB_ScrollFrame, 0);
	MetaKB_BuildSearchResults();
	MetaKB_UpdateScrollFrame();
	MetaKB_SearchEditBox:SetText(g_LastSearch);
end

function MetaKB_ScrollFrameButtonOnClick(button)
	MetaKB_ScrollFrameButtonID = this:GetID();
	if(button == "LeftButton") then
		if(IsControlKeyDown() or IsShiftKeyDown()) then
			-- Maybe for other functions.
		else
			local x, y = GetCursorPosition();
			x = x / UIParent:GetEffectiveScale();
			y = y / UIParent:GetEffectiveScale();
			MetaKBMenu:SetPoint("TOP", "UIParent", "BOTTOMLEFT", x , y +10);
			MetaKBMenu:Show();
		end
	elseif(button == "RightButton") then
		MetaKBMenu_RBSelect();
	end
end

function MetaKBMenu_Select(id)
	local name = getglobal("MetaKB_ScrollFrameButton"..MetaKB_ScrollFrameButtonID.."Name"):GetText();
	local zoneName = getglobal("MetaKB_ScrollFrameButton"..MetaKB_ScrollFrameButtonID.."Coords"):GetText();
	if(string.find(zoneName, "%(%d+\.?-?%d*%)?, %(?%d+\.?-?%d*%)")) then
		zoneName = GetRealZoneText();
	end
	local continent, zone = MetaMap_NameToZoneID(zoneName);
	local tUpdate = MetaMapOptions.ShowUpdates;

	if(id == 1) then
		MetaMapOptions.ShowUpdates = true;
		PlaySound("MapPing");
		MetaKB_AddMapNotes(name, zoneName, 0);
		MetaMapNotes_MapUpdate();
		PlaySound("igMiniMapClose");
	elseif(id == 2) then
		MetaMapOptions.ShowUpdates = true;
		PlaySound("MapPing");
		MetaKB_AddMapNotes(name, zoneName, 2);
		PlaySound("igMainMenuOption")
	elseif(id == 3) then
		MetaMapOptions.ShowUpdates = true;
		if MetaMapNotes_DeleteNotesByCreatorAndName ~= nil then
			MetaMapNotes_DeleteNotesByCreatorAndName(TEXT(METAKB_AUTHOR), name);
		end
	elseif(id == 4) then
		MetaMapOptions.ShowUpdates = true;
		PlaySound("igQuestLogAbandonQuest");
		MetaMapNotes_DeleteNotesByCreatorAndName(TEXT(METAKB_AUTHOR));
	elseif(id == 5) then
		MetaKB_Data[MetaKB_dbID][name] = nil;
		PlaySound("Deathbind Sound");
		MetaMap_StatusPrint(format(TEXT(METAKB_REMOVED_FROM_DATABASE), name, zoneName), true);
		MetaKB_Search(g_LastSearch, true);
	elseif(id == 6) then
			StaticPopupDialogs["Trim_Dbase"] = {
				text = TEXT(METAKB_TRIM_DBASE),
				button1 = TEXT(ACCEPT),
				button2 = TEXT(DECLINE),
				OnAccept = function()
					MetaKB_TrimDatabase();
				end,
				timeout = 60,
				showAlert = 1,
			};
			StaticPopup_Show("Trim_Dbase");
	elseif(id == 7 and ChatFrameEditBox:IsVisible()) then
		local coords = MetaKB_Data[MetaKB_dbID][name][continent][zone];
		local dx = coords[2]/100 - coords[4]/100;
		local dy = coords[3]/100 - coords[1]/100;
		local centerx = coords[4]/100 + dx/2;
		local centery = coords[1]/100 + dy/2;
		centerx = MetaMap_round(centerx, 0);
		centery = MetaMap_round(centery, 0);
		local mInfo = " "
		if(coords.inf1 ~= "") then mInfo = " ["..coords.inf1.."] "; end
		local coordString = centerx..", "..centery;
		ChatFrameEditBox:Insert(name..mInfo.."("..zoneName.." - "..coordString..")");
	elseif(id == 8) then
		local noteID = 0;
		MetaKBMenu:Hide();
		MetaKB_MainFrame:GetParent():Hide();
		ShowUIPanel(WorldMapFrame);
		if(continent == 0) then
			MetaMapOptions.MetaMapZone = zone;
			MetaMap_Toggle(true);
		else
			SetMapZoom(continent, zone);
		end
		for index, value in MetaMapNotes_Data[continent][zone], 1 do
			if(MetaMapNotes_Data[continent][zone][index].name == name) then
				noteID = index;
				break;
			end
		end
		if(noteID == 0 and MetaMapOptions.SetMapShow and not MetaMapFrame:IsVisible()) then
			MetaKB_AddMapNotes(name, zoneName, 0);
			MetaMapNotes_MapUpdate();
			noteID = MetaMapNotes_ZoneNotes;
		end
		if(noteID > 0) then
			MetaMapPing_SetPing(noteID + MetaMap_ListOffset);
		end
	end
	MetaMapOptions.ShowUpdates = tUpdate;
end

function MetaKBMenu_OnUpdate()
	if (MetaKBMenu:IsVisible()) then
		if (not MouseIsOver(MetaKBMenu)) then
			MetaKBMenu:Hide();
		end
	end
end

function MetaKB_TrimDatabase()
	local nameCount = 0;

	for i=1, table.getn(g_SearchResults) do
		local Name = g_SearchResults[i].name;
		MetaKB_Data[MetaKB_dbID][Name] = nil;
		nameCount = nameCount + 1
	end
	if(strlen(g_LastSearch) > 0) then
		MetaMap_StatusPrint("Removed "..nameCount.." entries from database linked to '"..g_LastSearch.."'", true);
	else
		MetaMap_StatusPrint("Removed ALL entries from database", true);
	end
	MetaKB_Search(g_LastSearch, true);
end

function MetaKB_AddMapNotes(name, zoneName, mininote)
	if(mininote == nil) then mininote = 0; end
	local continent, zone = MetaMap_NameToZoneID(zoneName);
	local currentZone = MetaKB_Data[MetaKB_dbID][name][continent][zone];
	local coordSets = {
	[1] = { ["n"] = TEXT(METAKB_MAPNOTES_NW_BOUND), ["x"] = 4, ["y"] = 1, },
	[2] = { ["n"] = TEXT(METAKB_MAPNOTES_NE_BOUND), ["x"] = 2, ["y"] = 1, },
	[3] = { ["n"] = TEXT(METAKB_MAPNOTES_SE_BOUND), ["x"] = 2, ["y"] = 3, },
	[4] = { ["n"] = TEXT(METAKB_MAPNOTES_SW_BOUND), ["x"] = 4, ["y"] = 3, }, };
	local coords = currentZone;
	local infoOne = currentZone["inf1"];
	local infoTwo = currentZone["inf2"];
	local icon = currentZone["icon"];
	local namecol = icon;
	if(icon == 1) then namecol = 2;
	elseif(icon == 2) then namecol = 6;
	elseif(icon == 3) then namecol = 4;
	elseif(icon == 6) then namecol = 1; end
	local dx = coords[2]/100 - coords[4]/100;
	local dy = coords[3]/100 - coords[1]/100;
	local centerx = coords[4]/100 + dx/2;
	local centery = coords[1]/100 + dy/2;
	centerx = MetaMap_round(centerx, 2);
	centery = MetaMap_round(centery, 2);
	if(centerx == 0 and centery == 0) then
		centerx = 75;
		centery = 95;
	end
	centerx = centerx/100;
	centery = centery/100;
	local noteAdded, nearNote = MetaMapNotes_AddNewNote(continent, zone, centerx, centery, name, infoOne, infoTwo, METAKB_AUTHOR, icon, namecol, 9, 6, mininote);
	if(noteAdded) then
		if(mininote ~= 2) then
			MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_NOTE, MetaMap_ZoneNames[continent][zone]), MetaMapOptions.ShowUpdates);
		end
	else
		MetaMap_StatusPrint(format(METAMAPNOTES_DECLINE_NOTE, MetaMapNotes_Data[continent][zone][nearNote].name, MetaMap_ZoneNames[continent][zone]), MetaMapOptions.ShowUpdates);
	end
	if(mininote > 0) then
		MetaMap_StatusPrint(format(METAMAPNOTES_ACCEPT_MININOTE, GetRealZoneText()), true);
	end
	if((dx >= 3 or dy >= 3) and MetaMapOptions.CreateMapNotesBoundingBox) then
		local x2 = coords[4]/10000
		local y2 = coords[3]/10000
		local skipNext = false
		for i in coordSets do
			local x1 = coords[coordSets[i].x]/10000
			local y1 = coords[coordSets[i].y]/10000
			noteAdded = MetaMapNotes_AddNewNote(continent, zone, x1, y1, name, infoOne, infoTwo, METAKB_AUTHOR, icon, namecol, 9, 6);
			if(noteAdded) then
				if not skipNext then
					MetaMapNotes_ToggleLine(continent, zone, x1, y1, x2, y2);
				end
				skipNext = false;
			else
				skipNext = true;
			end
		end
		x2,y2 = x1,y1;
	end
end

function MetaKB_ToggleAllZones()
	MetaKB_ShowAllZones = not MetaKB_ShowAllZones;
	if MetaKB_ShowAllZones then
		this:SetText(METAKB_SHOW_LOCALZONE);
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		this:SetText(METAKB_SHOW_ALLZONES);
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
	MetaKB_Search();
end

function MetaKB_ToggleAutoTrack()
	MetaMapOptions.AutoTrack = not MetaMapOptions.AutoTrack;
	if(MetaMapOptions.AutoTrack) then
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end

function MetaKB_OnEnter(header, anchor, wrap, ...)
	assert(header ~= nil and anchor ~= nil and wrap ~= nil, "ERROR: nil arguments passed to MetaKB_OnEnter!");
	local myArgs = { unpack(arg) };
	assert(table.getn(myArgs) < 30, "ERROR: too many arguments passed to MetaKB_OnEnter!");

	MetaKB_Tooltip:ClearLines();
	local xOffset, yOffset;
	if string.find(anchor, "TOP") ~= nil then
		yOffset = -5;
	elseif string.find(anchor, "BOTTOM") ~= nil then
		yOffset = 5;
	end

	if string.find(anchor, "RIGHT") ~= nil then
		xOffset = -5;
	elseif string.find(anchor, "LEFT") ~= nil then
		xOffset = 5;
	end
	MetaKB_Tooltip:SetOwner(this, anchor, xOffset, yOffset);
	MetaKB_Tooltip:SetText(header, 0.2, 0.5, 1, 1);
	for i,string in myArgs do
		MetaKB_Tooltip:AddLine(string, 1, 1, 1, MetaMapOptions.TooltipWrap);
	end
	MetaKB_Tooltip:Show();
end

function MetaKB_ToggleShowUpdates()
	MetaMapOptions.ShowUpdates = not MetaMapOptions.ShowUpdates
	if MetaMapOptions.ShowUpdates then
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end

function MetaKB_ToggleDbase()
	MetaMapOptions.KBstate = not MetaMapOptions.KBstate;
	if MetaMapOptions.KBstate then
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end

function MetaKB_ToggleSetNote()
	MetaMapOptions.NewTargetNote = not MetaMapOptions.NewTargetNote
	if MetaMapOptions.NewTargetNote then
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end

function MetaKB_ToggleBoundingBox()
	MetaMapOptions.CreateMapNotesBoundingBox = not MetaMapOptions.CreateMapNotesBoundingBox;
	if MetaMapOptions.CreateMapNotesBoundingBox then
		PlaySound("igMainMenuOptionCheckBoxOn");
	else
		PlaySound("igMainMenuOptionCheckBoxOff");
	end
end

function MetaKBMenu_RBSelect()
	-- Available for other mods to run their own routine.
	-- Initiated when RightClicking on KB display item.
	-- Usage: MetaKBMenu_RBSelect = MyFunction
end

function MetaMapNotes_RBSelect()
	-- Available for other mods to run their own routine.
	-- Initiated when RightClicking on a map note.
	-- Usage: MetaMapNotes_RBSelect = MyFunction
end

----------------
-- Titan Support
----------------
function TitanPanelMetaMapButton_OnLoad()
	this.registry = { 
		id = TITAN_METAMAP_ID,
		version = METAMAP_VERSION,
		menuText = METAMAP_TITLE,
		category = METAMAP_CATEGORY,
		tooltipTitle = METAMAP_TITLE ,
		tooltipTextFunction = "TitanPanelMetaMapButton_GetTooltipText",
		frequency = TITAN_METAMAP_FREQUENCY, 
		icon = METAMAP_ICON,
		iconWidth = 16,
		savedVariables = {
		ShowIcon = 1,
		}
	};
end

function TitanPanelMetaMapButton_GetTooltipText()
	if(MetaMapOptions.MenuMode) then
		retText = METAMAP_BUTTON_TOOLTIP1.."\n"..METAMAP_BUTTON_TOOLTIP2;
		return retText;
	end
end

function TitalPanelMetaMapButton_OnClick(button)
	if ( button == "LeftButton" ) then
		MetaMap_ToggleFrame(WorldMapFrame);
	end
end

---------
-- CT_Mod
---------
if(IsAddOnLoaded("CT_MapMod")) then
	CT_CoordX:Hide();
	CT_CoordY:Hide();
	CT_NumNotes:SetPoint("TOPLEFT","WorldMapMagnifyingGlassButton","TOPLEFT",10,10);
	WorldMapFrameCreateNoteOnPlayer:SetPoint("RIGHT","WorldMapContinentDropDown","LEFT",-190,0);
end

-----------
-- FlightMap
-----------
function FlightMapOptions_Toggle()
	FlightMapOptionsFrame:SetFrameStrata("FULLSCREEN");
	MetaMap_ToggleFrame(FlightMapOptionsFrame);
end

-----------
-- Gatherer
-----------
function GathererOptions_Toggle()
	GathererUI_DialogFrame:SetFrameStrata("FULLSCREEN");
	MetaMap_ToggleFrame(GathererUI_DialogFrame);
end

------------------
-- BetterWaypoints
------------------
function BWP_Toggle()
	BetterWaypointsOptionsForm:SetFrameStrata("FULLSCREEN");
	MetaMap_ToggleFrame(BetterWaypointsOptionsForm);
end

